/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "./environments";
import * as core from "./core";
import { Ats } from "./api/resources/ats/client/Client";
import { Crm } from "./api/resources/crm/client/Client";
import { Filestorage } from "./api/resources/filestorage/client/Client";
import { Hris } from "./api/resources/hris/client/Client";
import { Ticketing } from "./api/resources/ticketing/client/Client";
import { Accounting } from "./api/resources/accounting/client/Client";
export declare namespace MergeClient {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class MergeClient {
    protected readonly _options: MergeClient.Options;
    protected _ats: Ats | undefined;
    protected _crm: Crm | undefined;
    protected _filestorage: Filestorage | undefined;
    protected _hris: Hris | undefined;
    protected _ticketing: Ticketing | undefined;
    protected _accounting: Accounting | undefined;
    constructor(_options: MergeClient.Options);
    get ats(): Ats;
    get crm(): Crm;
    get filestorage(): Filestorage;
    get hris(): Hris;
    get ticketing(): Ticketing;
    get accounting(): Accounting;
}
