/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import { AccountDetails } from "../resources/accountDetails/client/Client";
import { AccountToken } from "../resources/accountToken/client/Client";
import { AccountingPeriods } from "../resources/accountingPeriods/client/Client";
import { Accounts } from "../resources/accounts/client/Client";
import { Addresses } from "../resources/addresses/client/Client";
import { AsyncPassthrough } from "../resources/asyncPassthrough/client/Client";
import { AsyncTasks } from "../resources/asyncTasks/client/Client";
import { Attachments } from "../resources/attachments/client/Client";
import { AuditTrail } from "../resources/auditTrail/client/Client";
import { AvailableActions } from "../resources/availableActions/client/Client";
import { BalanceSheets } from "../resources/balanceSheets/client/Client";
import { BankFeedAccounts } from "../resources/bankFeedAccounts/client/Client";
import { BankFeedTransactions } from "../resources/bankFeedTransactions/client/Client";
import { CashFlowStatements } from "../resources/cashFlowStatements/client/Client";
import { CompanyInfo } from "../resources/companyInfo/client/Client";
import { Contacts } from "../resources/contacts/client/Client";
import { CreditNotes } from "../resources/creditNotes/client/Client";
import { Scopes } from "../resources/scopes/client/Client";
import { DeleteAccount } from "../resources/deleteAccount/client/Client";
import { Employees } from "../resources/employees/client/Client";
import { Expenses } from "../resources/expenses/client/Client";
import { FieldMapping } from "../resources/fieldMapping/client/Client";
import { GeneralLedgerTransactions } from "../resources/generalLedgerTransactions/client/Client";
import { GenerateKey } from "../resources/generateKey/client/Client";
import { IncomeStatements } from "../resources/incomeStatements/client/Client";
import { Invoices } from "../resources/invoices/client/Client";
import { Issues } from "../resources/issues/client/Client";
import { Items } from "../resources/items/client/Client";
import { JournalEntries } from "../resources/journalEntries/client/Client";
import { LinkToken } from "../resources/linkToken/client/Client";
import { LinkedAccounts } from "../resources/linkedAccounts/client/Client";
import { Passthrough } from "../resources/passthrough/client/Client";
import { PaymentMethods } from "../resources/paymentMethods/client/Client";
import { PaymentTerms } from "../resources/paymentTerms/client/Client";
import { Payments } from "../resources/payments/client/Client";
import { PhoneNumbers } from "../resources/phoneNumbers/client/Client";
import { PurchaseOrders } from "../resources/purchaseOrders/client/Client";
import { RegenerateKey } from "../resources/regenerateKey/client/Client";
import { SyncStatus } from "../resources/syncStatus/client/Client";
import { ForceResync } from "../resources/forceResync/client/Client";
import { TaxRates } from "../resources/taxRates/client/Client";
import { TrackingCategories } from "../resources/trackingCategories/client/Client";
import { Transactions } from "../resources/transactions/client/Client";
import { VendorCredits } from "../resources/vendorCredits/client/Client";
import { WebhookReceivers } from "../resources/webhookReceivers/client/Client";
export declare namespace Accounting {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
}
export declare class Accounting {
    protected readonly _options: Accounting.Options;
    protected _accountDetails: AccountDetails | undefined;
    protected _accountToken: AccountToken | undefined;
    protected _accountingPeriods: AccountingPeriods | undefined;
    protected _accounts: Accounts | undefined;
    protected _addresses: Addresses | undefined;
    protected _asyncPassthrough: AsyncPassthrough | undefined;
    protected _asyncTasks: AsyncTasks | undefined;
    protected _attachments: Attachments | undefined;
    protected _auditTrail: AuditTrail | undefined;
    protected _availableActions: AvailableActions | undefined;
    protected _balanceSheets: BalanceSheets | undefined;
    protected _bankFeedAccounts: BankFeedAccounts | undefined;
    protected _bankFeedTransactions: BankFeedTransactions | undefined;
    protected _cashFlowStatements: CashFlowStatements | undefined;
    protected _companyInfo: CompanyInfo | undefined;
    protected _contacts: Contacts | undefined;
    protected _creditNotes: CreditNotes | undefined;
    protected _scopes: Scopes | undefined;
    protected _deleteAccount: DeleteAccount | undefined;
    protected _employees: Employees | undefined;
    protected _expenses: Expenses | undefined;
    protected _fieldMapping: FieldMapping | undefined;
    protected _generalLedgerTransactions: GeneralLedgerTransactions | undefined;
    protected _generateKey: GenerateKey | undefined;
    protected _incomeStatements: IncomeStatements | undefined;
    protected _invoices: Invoices | undefined;
    protected _issues: Issues | undefined;
    protected _items: Items | undefined;
    protected _journalEntries: JournalEntries | undefined;
    protected _linkToken: LinkToken | undefined;
    protected _linkedAccounts: LinkedAccounts | undefined;
    protected _passthrough: Passthrough | undefined;
    protected _paymentMethods: PaymentMethods | undefined;
    protected _paymentTerms: PaymentTerms | undefined;
    protected _payments: Payments | undefined;
    protected _phoneNumbers: PhoneNumbers | undefined;
    protected _purchaseOrders: PurchaseOrders | undefined;
    protected _regenerateKey: RegenerateKey | undefined;
    protected _syncStatus: SyncStatus | undefined;
    protected _forceResync: ForceResync | undefined;
    protected _taxRates: TaxRates | undefined;
    protected _trackingCategories: TrackingCategories | undefined;
    protected _transactions: Transactions | undefined;
    protected _vendorCredits: VendorCredits | undefined;
    protected _webhookReceivers: WebhookReceivers | undefined;
    constructor(_options: Accounting.Options);
    get accountDetails(): AccountDetails;
    get accountToken(): AccountToken;
    get accountingPeriods(): AccountingPeriods;
    get accounts(): Accounts;
    get addresses(): Addresses;
    get asyncPassthrough(): AsyncPassthrough;
    get asyncTasks(): AsyncTasks;
    get attachments(): Attachments;
    get auditTrail(): AuditTrail;
    get availableActions(): AvailableActions;
    get balanceSheets(): BalanceSheets;
    get bankFeedAccounts(): BankFeedAccounts;
    get bankFeedTransactions(): BankFeedTransactions;
    get cashFlowStatements(): CashFlowStatements;
    get companyInfo(): CompanyInfo;
    get contacts(): Contacts;
    get creditNotes(): CreditNotes;
    get scopes(): Scopes;
    get deleteAccount(): DeleteAccount;
    get employees(): Employees;
    get expenses(): Expenses;
    get fieldMapping(): FieldMapping;
    get generalLedgerTransactions(): GeneralLedgerTransactions;
    get generateKey(): GenerateKey;
    get incomeStatements(): IncomeStatements;
    get invoices(): Invoices;
    get issues(): Issues;
    get items(): Items;
    get journalEntries(): JournalEntries;
    get linkToken(): LinkToken;
    get linkedAccounts(): LinkedAccounts;
    get passthrough(): Passthrough;
    get paymentMethods(): PaymentMethods;
    get paymentTerms(): PaymentTerms;
    get payments(): Payments;
    get phoneNumbers(): PhoneNumbers;
    get purchaseOrders(): PurchaseOrders;
    get regenerateKey(): RegenerateKey;
    get syncStatus(): SyncStatus;
    get forceResync(): ForceResync;
    get taxRates(): TaxRates;
    get trackingCategories(): TrackingCategories;
    get transactions(): Transactions;
    get vendorCredits(): VendorCredits;
    get webhookReceivers(): WebhookReceivers;
}
