/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace BankFeedTransactions {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class BankFeedTransactions {
    protected readonly _options: BankFeedTransactions.Options;
    constructor(_options: BankFeedTransactions.Options);
    /**
     * Returns a list of `BankFeedTransaction` objects.
     *
     * @param {Merge.accounting.BankFeedTransactionsListRequest} request
     * @param {BankFeedTransactions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedTransactions.list()
     */
    list(request?: Merge.accounting.BankFeedTransactionsListRequest, requestOptions?: BankFeedTransactions.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedBankFeedTransactionList>;
    private __list;
    /**
     * Creates a `BankFeedTransaction` object with the given values.
     *
     * @param {Merge.accounting.BankFeedTransactionEndpointRequest} request
     * @param {BankFeedTransactions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedTransactions.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.BankFeedTransactionEndpointRequest, requestOptions?: BankFeedTransactions.RequestOptions): core.HttpResponsePromise<Merge.accounting.BankFeedTransactionResponse>;
    private __create;
    /**
     * Returns a `BankFeedTransaction` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.BankFeedTransactionsRetrieveRequest} request
     * @param {BankFeedTransactions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedTransactions.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.BankFeedTransactionsRetrieveRequest, requestOptions?: BankFeedTransactions.RequestOptions): core.HttpResponsePromise<Merge.accounting.BankFeedTransaction>;
    private __retrieve;
    /**
     * Returns metadata for `BankFeedTransaction` POSTs.
     *
     * @param {BankFeedTransactions.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedTransactions.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: BankFeedTransactions.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
