/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace CreditNotes {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class CreditNotes {
    protected readonly _options: CreditNotes.Options;
    constructor(_options: CreditNotes.Options);
    /**
     * Returns a list of `CreditNote` objects.
     *
     * @param {Merge.accounting.CreditNotesListRequest} request
     * @param {CreditNotes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.creditNotes.list()
     */
    list(request?: Merge.accounting.CreditNotesListRequest, requestOptions?: CreditNotes.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedCreditNoteList>;
    private __list;
    /**
     * Creates a `CreditNote` object with the given values.
     *
     * @param {Merge.accounting.CreditNoteEndpointRequest} request
     * @param {CreditNotes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.creditNotes.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.CreditNoteEndpointRequest, requestOptions?: CreditNotes.RequestOptions): core.HttpResponsePromise<Merge.accounting.CreditNoteResponse>;
    private __create;
    /**
     * Returns a `CreditNote` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.CreditNotesRetrieveRequest} request
     * @param {CreditNotes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.creditNotes.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.CreditNotesRetrieveRequest, requestOptions?: CreditNotes.RequestOptions): core.HttpResponsePromise<Merge.accounting.CreditNote>;
    private __retrieve;
    /**
     * Returns metadata for `CreditNote` POSTs.
     *
     * @param {CreditNotes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.creditNotes.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: CreditNotes.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
