/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Expenses {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Expenses {
    protected readonly _options: Expenses.Options;
    constructor(_options: Expenses.Options);
    /**
     * Returns a list of `Expense` objects.
     *
     * @param {Merge.accounting.ExpensesListRequest} request
     * @param {Expenses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenses.list()
     */
    list(request?: Merge.accounting.ExpensesListRequest, requestOptions?: Expenses.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedExpenseList>;
    private __list;
    /**
     * Creates an `Expense` object with the given values.
     *
     * @param {Merge.accounting.ExpenseEndpointRequest} request
     * @param {Expenses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenses.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.ExpenseEndpointRequest, requestOptions?: Expenses.RequestOptions): core.HttpResponsePromise<Merge.accounting.ExpenseResponse>;
    private __create;
    /**
     * Returns an `Expense` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.ExpensesRetrieveRequest} request
     * @param {Expenses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenses.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.ExpensesRetrieveRequest, requestOptions?: Expenses.RequestOptions): core.HttpResponsePromise<Merge.accounting.Expense>;
    private __retrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.ExpensesLinesRemoteFieldClassesListRequest} request
     * @param {Expenses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenses.linesRemoteFieldClassesList()
     */
    linesRemoteFieldClassesList(request?: Merge.accounting.ExpensesLinesRemoteFieldClassesListRequest, requestOptions?: Expenses.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __linesRemoteFieldClassesList;
    /**
     * Returns metadata for `Expense` POSTs.
     *
     * @param {Expenses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenses.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Expenses.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.ExpensesRemoteFieldClassesListRequest} request
     * @param {Expenses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenses.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.accounting.ExpensesRemoteFieldClassesListRequest, requestOptions?: Expenses.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
