/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace JournalEntries {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class JournalEntries {
    protected readonly _options: JournalEntries.Options;
    constructor(_options: JournalEntries.Options);
    /**
     * Returns a list of `JournalEntry` objects.
     *
     * @param {Merge.accounting.JournalEntriesListRequest} request
     * @param {JournalEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.journalEntries.list()
     */
    list(request?: Merge.accounting.JournalEntriesListRequest, requestOptions?: JournalEntries.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedJournalEntryList>;
    private __list;
    /**
     * Creates a `JournalEntry` object with the given values.
     *
     * @param {Merge.accounting.JournalEntryEndpointRequest} request
     * @param {JournalEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.journalEntries.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.JournalEntryEndpointRequest, requestOptions?: JournalEntries.RequestOptions): core.HttpResponsePromise<Merge.accounting.JournalEntryResponse>;
    private __create;
    /**
     * Returns a `JournalEntry` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.JournalEntriesRetrieveRequest} request
     * @param {JournalEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.journalEntries.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.JournalEntriesRetrieveRequest, requestOptions?: JournalEntries.RequestOptions): core.HttpResponsePromise<Merge.accounting.JournalEntry>;
    private __retrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.JournalEntriesLinesRemoteFieldClassesListRequest} request
     * @param {JournalEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.journalEntries.linesRemoteFieldClassesList()
     */
    linesRemoteFieldClassesList(request?: Merge.accounting.JournalEntriesLinesRemoteFieldClassesListRequest, requestOptions?: JournalEntries.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __linesRemoteFieldClassesList;
    /**
     * Returns metadata for `JournalEntry` POSTs.
     *
     * @param {JournalEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.journalEntries.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: JournalEntries.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.JournalEntriesRemoteFieldClassesListRequest} request
     * @param {JournalEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.journalEntries.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.accounting.JournalEntriesRemoteFieldClassesListRequest, requestOptions?: JournalEntries.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
