/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace PaymentMethods {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class PaymentMethods {
    protected readonly _options: PaymentMethods.Options;
    constructor(_options: PaymentMethods.Options);
    /**
     * Returns a list of `PaymentMethod` objects.
     *
     * @param {Merge.accounting.PaymentMethodsListRequest} request
     * @param {PaymentMethods.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.paymentMethods.list()
     */
    list(request?: Merge.accounting.PaymentMethodsListRequest, requestOptions?: PaymentMethods.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedPaymentMethodList>;
    private __list;
    /**
     * Returns a `PaymentMethod` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PaymentMethodsRetrieveRequest} request
     * @param {PaymentMethods.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.paymentMethods.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.PaymentMethodsRetrieveRequest, requestOptions?: PaymentMethods.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaymentMethod>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
