/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace PhoneNumbers {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class PhoneNumbers {
    protected readonly _options: PhoneNumbers.Options;
    constructor(_options: PhoneNumbers.Options);
    /**
     * Returns an `AccountingPhoneNumber` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PhoneNumbersRetrieveRequest} request
     * @param {PhoneNumbers.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.phoneNumbers.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.PhoneNumbersRetrieveRequest, requestOptions?: PhoneNumbers.RequestOptions): core.HttpResponsePromise<Merge.accounting.AccountingPhoneNumber>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
