/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The CreditNoteLineItem Object
 * ### Description
 * The `CreditNoteLineItem` object is used to represent a credit note's line items.
 *
 * ### Usage Example
 * Fetch from the `GET CreditNote` endpoint and view the credit note's line items.
 */
export interface CreditNoteLineItem {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    item?: Merge.accounting.CreditNoteLineItemItem;
    /** The credit note line item's name. */
    name?: string;
    /** The description of the item that is owed. */
    description?: string;
    /** The credit note line item's quantity. */
    quantity?: string;
    /** The credit note line item's memo. */
    memo?: string;
    /** The credit note line item's unit price. */
    unitPrice?: string;
    /** The tax rate that applies to this line item. */
    taxRate?: string;
    /** The credit note line item's total. */
    totalLineAmount?: string;
    /** The credit note line item's associated tracking category. */
    trackingCategory?: string;
    /** The credit note line item's associated tracking categories. */
    trackingCategories?: (string | undefined)[];
    /** The credit note line item's account. */
    account?: string;
    /** The company the credit note belongs to. */
    company?: Merge.accounting.CreditNoteLineItemCompany;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
}
