/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Item Object
 * ### Description
 * The `Item` object refers to the goods involved in a transaction.
 *
 * ### Usage Example
 * Fetch from the `LIST Items` endpoint and view a company's items.
 */
export interface Item {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The item's name. */
    name?: string;
    /**
     * The item's status.
     *
     * * `ACTIVE` - ACTIVE
     * * `ARCHIVED` - ARCHIVED
     */
    status?: Merge.accounting.ItemStatus;
    /** The item's unit price. */
    unitPrice?: number;
    /** The price at which the item is purchased from a vendor. */
    purchasePrice?: number;
    /** References the default account used to record a purchase of the item. */
    purchaseAccount?: Merge.accounting.ItemPurchaseAccount;
    /** References the default account used to record a sale. */
    salesAccount?: Merge.accounting.ItemSalesAccount;
    /** The company the item belongs to. */
    company?: Merge.accounting.ItemCompany;
    /** The default purchase tax rate for this item. */
    purchaseTaxRate?: Merge.accounting.ItemPurchaseTaxRate;
    /** The default sales tax rate for this item. */
    salesTaxRate?: Merge.accounting.ItemSalesTaxRate;
    /** When the third party's item note was updated. */
    remoteUpdatedAt?: Date;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.accounting.RemoteData[];
}
