/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The PaymentTerm Object
 * ### Description
 * The `PaymentTerm` object is the agreed-upon conditions between a buyer and a seller that define the timing,
 * amount, and conditions under which payment for goods or services must be made.
 *
 * ### Usage Example
 * Fetch from the `GET PaymentTerm` endpoint and view payment term information.
 */
export interface PaymentTerm {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The name of the payment term. */
    name: string;
    /** `True` if the payment term is active, `False` if not. */
    isActive?: boolean;
    /** The subsidiary that the payment term belongs to. */
    company?: Merge.accounting.PaymentTermCompany;
    /** The number of days after the invoice date that payment is due. */
    daysUntilDue?: number;
    /** The number of days the invoice must be paid before discounts expire. */
    discountDays?: number;
    /** When the third party's payment term was modified. */
    remoteLastModifiedAt?: Date;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.accounting.RemoteData[];
}
