/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The TaxRate Object
 * ### Description
 * The `TaxComponent` object is used to represent any sub-taxes that make up the `TaxRate`.
 *
 * ### Usage Example
 * Fetch from the `LIST TaxRates` endpoint and view tax components relevant to a tax rate.
 */
export interface TaxComponent {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The tax rate’s name. */
    name?: string;
    /** The tax component’s rate. */
    rate?: string;
    /** Returns True if the tax component is compound, False if not. */
    isCompound?: boolean;
    /**
     * Returns PURCHASE if the tax component corresponds to a purchase tax or SALES if the tax component corresponds to a sales tax.
     *
     * * `SALES` - SALES
     * * `PURCHASE` - PURCHASE
     */
    componentType?: Merge.accounting.TaxComponentComponentType;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
}
