/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Eeocs {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Eeocs {
    protected readonly _options: Eeocs.Options;
    constructor(_options: Eeocs.Options);
    /**
     * Returns a list of `EEOC` objects.
     *
     * @param {Merge.ats.EeocsListRequest} request
     * @param {Eeocs.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.eeocs.list()
     */
    list(request?: Merge.ats.EeocsListRequest, requestOptions?: Eeocs.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedEeocList>;
    private __list;
    /**
     * Returns an `EEOC` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.EeocsRetrieveRequest} request
     * @param {Eeocs.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.eeocs.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.EeocsRetrieveRequest, requestOptions?: Eeocs.RequestOptions): core.HttpResponsePromise<Merge.ats.Eeoc>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
