/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace JobInterviewStages {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class JobInterviewStages {
    protected readonly _options: JobInterviewStages.Options;
    constructor(_options: JobInterviewStages.Options);
    /**
     * Returns a list of `JobInterviewStage` objects.
     *
     * @param {Merge.ats.JobInterviewStagesListRequest} request
     * @param {JobInterviewStages.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.jobInterviewStages.list()
     */
    list(request?: Merge.ats.JobInterviewStagesListRequest, requestOptions?: JobInterviewStages.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedJobInterviewStageList>;
    private __list;
    /**
     * Returns a `JobInterviewStage` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.JobInterviewStagesRetrieveRequest} request
     * @param {JobInterviewStages.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.jobInterviewStages.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.JobInterviewStagesRetrieveRequest, requestOptions?: JobInterviewStages.RequestOptions): core.HttpResponsePromise<Merge.ats.JobInterviewStage>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
