/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Jobs {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Jobs {
    protected readonly _options: Jobs.Options;
    constructor(_options: Jobs.Options);
    /**
     * Returns a list of `Job` objects.
     *
     * @param {Merge.ats.JobsListRequest} request
     * @param {Jobs.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.jobs.list()
     */
    list(request?: Merge.ats.JobsListRequest, requestOptions?: Jobs.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedJobList>;
    private __list;
    /**
     * Returns a `Job` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.JobsRetrieveRequest} request
     * @param {Jobs.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.jobs.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.JobsRetrieveRequest, requestOptions?: Jobs.RequestOptions): core.HttpResponsePromise<Merge.ats.Job>;
    private __retrieve;
    /**
     * Returns a list of `ScreeningQuestion` objects.
     *
     * @param {string} jobId
     * @param {Merge.ats.JobsScreeningQuestionsListRequest} request
     * @param {Jobs.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.jobs.screeningQuestionsList("job_id")
     */
    screeningQuestionsList(jobId: string, request?: Merge.ats.JobsScreeningQuestionsListRequest, requestOptions?: Jobs.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedScreeningQuestionList>;
    private __screeningQuestionsList;
    protected _getAuthorizationHeader(): Promise<string>;
}
