/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Scorecards {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Scorecards {
    protected readonly _options: Scorecards.Options;
    constructor(_options: Scorecards.Options);
    /**
     * Returns a list of `Scorecard` objects.
     *
     * @param {Merge.ats.ScorecardsListRequest} request
     * @param {Scorecards.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.scorecards.list()
     */
    list(request?: Merge.ats.ScorecardsListRequest, requestOptions?: Scorecards.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedScorecardList>;
    private __list;
    /**
     * Returns a `Scorecard` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.ScorecardsRetrieveRequest} request
     * @param {Scorecards.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.scorecards.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.ScorecardsRetrieveRequest, requestOptions?: Scorecards.RequestOptions): core.HttpResponsePromise<Merge.ats.Scorecard>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
