/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Attachment Object
 * ### Description
 * The `Attachment` object is used to represent a file attached to a candidate.
 * ### Usage Example
 * Fetch from the `LIST Attachments` endpoint and view attachments accessible by a company.
 */
export interface Attachment {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The attachment's name. */
    fileName?: string;
    /** The attachment's url. */
    fileUrl?: string;
    /** */
    candidate?: string;
    /**
     * The attachment's type.
     *
     * * `RESUME` - RESUME
     * * `COVER_LETTER` - COVER_LETTER
     * * `OFFER_LETTER` - OFFER_LETTER
     * * `OTHER` - OTHER
     */
    attachmentType?: Merge.ats.AttachmentAttachmentType;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.ats.RemoteData[];
}
