/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Job Object
 * ### Description
 * The `Job` object can be used to track any jobs that are currently or will be open/closed for applications.
 * ### Usage Example
 * Fetch from the `LIST Jobs` endpoint to show all job postings.
 */
export interface Job {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The job's name. */
    name?: string;
    /** The job's description. */
    description?: string;
    /** The job's code. Typically an additional identifier used to reference the particular job that is displayed on the ATS. */
    code?: string;
    /**
     * The job's status.
     *
     * * `OPEN` - OPEN
     * * `CLOSED` - CLOSED
     * * `DRAFT` - DRAFT
     * * `ARCHIVED` - ARCHIVED
     * * `PENDING` - PENDING
     */
    status?: Merge.ats.JobStatus;
    /**
     * The job's type.
     *
     * * `POSTING` - POSTING
     * * `REQUISITION` - REQUISITION
     * * `PROFILE` - PROFILE
     */
    type?: Merge.ats.JobTypeEnum;
    /** IDs of `JobPosting` objects that serve as job postings for this `Job`. */
    jobPostings?: (string | undefined)[];
    jobPostingUrls?: Merge.ats.Url[];
    /** When the third party's job was created. */
    remoteCreatedAt?: Date;
    /** When the third party's job was updated. */
    remoteUpdatedAt?: Date;
    /** Whether the job is confidential. */
    confidential?: boolean;
    /** IDs of `Department` objects for this `Job`. */
    departments?: (Merge.ats.JobDepartmentsItem | undefined)[];
    /** IDs of `Office` objects for this `Job`. */
    offices?: (Merge.ats.JobOfficesItem | undefined)[];
    /** IDs of `RemoteUser` objects that serve as hiring managers for this `Job`. */
    hiringManagers?: (Merge.ats.JobHiringManagersItem | undefined)[];
    /** IDs of `RemoteUser` objects that serve as recruiters for this `Job`. */
    recruiters?: (Merge.ats.JobRecruitersItem | undefined)[];
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.ats.RemoteData[];
}
