/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Accounts {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Accounts {
    protected readonly _options: Accounts.Options;
    constructor(_options: Accounts.Options);
    /**
     * Returns a list of `Account` objects.
     *
     * @param {Merge.crm.AccountsListRequest} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accounts.list()
     */
    list(request?: Merge.crm.AccountsListRequest, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedAccountList>;
    private __list;
    /**
     * Creates an `Account` object with the given values.
     *
     * @param {Merge.crm.CrmAccountEndpointRequest} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accounts.create({
     *         model: {}
     *     })
     */
    create(request: Merge.crm.CrmAccountEndpointRequest, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.crm.CrmAccountResponse>;
    private __create;
    /**
     * Returns an `Account` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.AccountsRetrieveRequest} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accounts.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.AccountsRetrieveRequest, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.crm.Account>;
    private __retrieve;
    /**
     * Updates an `Account` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.PatchedCrmAccountEndpointRequest} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accounts.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id: string, request: Merge.crm.PatchedCrmAccountEndpointRequest, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.crm.CrmAccountResponse>;
    private __partialUpdate;
    /**
     * Returns metadata for `CRMAccount` PATCHs.
     *
     * @param {string} id
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accounts.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id: string, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPatchRetrieve;
    /**
     * Returns metadata for `CRMAccount` POSTs.
     *
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accounts.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.AccountsRemoteFieldClassesListRequest} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accounts.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.AccountsRemoteFieldClassesListRequest, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
