/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace AssociationTypes {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class AssociationTypes {
    protected readonly _options: AssociationTypes.Options;
    constructor(_options: AssociationTypes.Options);
    /**
     * Returns a list of `AssociationType` objects.
     *
     * @param {string} customObjectClassId
     * @param {Merge.crm.CustomObjectClassesAssociationTypesListRequest} request
     * @param {AssociationTypes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.associationTypes.customObjectClassesAssociationTypesList("custom_object_class_id")
     */
    customObjectClassesAssociationTypesList(customObjectClassId: string, request?: Merge.crm.CustomObjectClassesAssociationTypesListRequest, requestOptions?: AssociationTypes.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedAssociationTypeList>;
    private __customObjectClassesAssociationTypesList;
    /**
     * Creates an `AssociationType` object with the given values.
     *
     * @param {string} customObjectClassId
     * @param {Merge.crm.CrmAssociationTypeEndpointRequest} request
     * @param {AssociationTypes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.associationTypes.customObjectClassesAssociationTypesCreate("custom_object_class_id", {
     *         model: {
     *             sourceObjectClass: {
     *                 id: "id",
     *                 originType: "CUSTOM_OBJECT"
     *             },
     *             targetObjectClasses: [{
     *                     id: "id",
     *                     originType: "CUSTOM_OBJECT"
     *                 }],
     *             remoteKeyName: "remote_key_name"
     *         }
     *     })
     */
    customObjectClassesAssociationTypesCreate(customObjectClassId: string, request: Merge.crm.CrmAssociationTypeEndpointRequest, requestOptions?: AssociationTypes.RequestOptions): core.HttpResponsePromise<Merge.crm.CrmAssociationTypeResponse>;
    private __customObjectClassesAssociationTypesCreate;
    /**
     * Returns an `AssociationType` object with the given `id`.
     *
     * @param {string} customObjectClassId
     * @param {string} id
     * @param {Merge.crm.CustomObjectClassesAssociationTypesRetrieveRequest} request
     * @param {AssociationTypes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.associationTypes.customObjectClassesAssociationTypesRetrieve("custom_object_class_id", "id")
     */
    customObjectClassesAssociationTypesRetrieve(customObjectClassId: string, id: string, request?: Merge.crm.CustomObjectClassesAssociationTypesRetrieveRequest, requestOptions?: AssociationTypes.RequestOptions): core.HttpResponsePromise<Merge.crm.AssociationType>;
    private __customObjectClassesAssociationTypesRetrieve;
    /**
     * Returns metadata for `CRMAssociationType` POSTs.
     *
     * @param {string} customObjectClassId
     * @param {AssociationTypes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.associationTypes.customObjectClassesAssociationTypesMetaPostRetrieve("custom_object_class_id")
     */
    customObjectClassesAssociationTypesMetaPostRetrieve(customObjectClassId: string, requestOptions?: AssociationTypes.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __customObjectClassesAssociationTypesMetaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
