/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Associations {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Associations {
    protected readonly _options: Associations.Options;
    constructor(_options: Associations.Options);
    /**
     * Returns a list of `Association` objects.
     *
     * @param {string} customObjectClassId
     * @param {string} objectId
     * @param {Merge.crm.CustomObjectClassesCustomObjectsAssociationsListRequest} request
     * @param {Associations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.associations.customObjectClassesCustomObjectsAssociationsList("custom_object_class_id", "object_id")
     */
    customObjectClassesCustomObjectsAssociationsList(customObjectClassId: string, objectId: string, request?: Merge.crm.CustomObjectClassesCustomObjectsAssociationsListRequest, requestOptions?: Associations.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedAssociationList>;
    private __customObjectClassesCustomObjectsAssociationsList;
    /**
     * Creates an Association between `source_object_id` and `target_object_id` of type `association_type_id`.
     *
     * @param {string} associationTypeId
     * @param {string} sourceClassId
     * @param {string} sourceObjectId
     * @param {string} targetClassId
     * @param {string} targetObjectId
     * @param {Merge.crm.CustomObjectClassesCustomObjectsAssociationsUpdateRequest} request
     * @param {Associations.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.associations.customObjectClassesCustomObjectsAssociationsUpdate("association_type_id", "source_class_id", "source_object_id", "target_class_id", "target_object_id")
     */
    customObjectClassesCustomObjectsAssociationsUpdate(associationTypeId: string, sourceClassId: string, sourceObjectId: string, targetClassId: string, targetObjectId: string, request?: Merge.crm.CustomObjectClassesCustomObjectsAssociationsUpdateRequest, requestOptions?: Associations.RequestOptions): core.HttpResponsePromise<Merge.crm.Association>;
    private __customObjectClassesCustomObjectsAssociationsUpdate;
    protected _getAuthorizationHeader(): Promise<string>;
}
