/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace CustomObjectClasses {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class CustomObjectClasses {
    protected readonly _options: CustomObjectClasses.Options;
    constructor(_options: CustomObjectClasses.Options);
    /**
     * Returns a list of `CustomObjectClass` objects.
     *
     * @param {Merge.crm.CustomObjectClassesListRequest} request
     * @param {CustomObjectClasses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.customObjectClasses.list()
     */
    list(request?: Merge.crm.CustomObjectClassesListRequest, requestOptions?: CustomObjectClasses.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedCustomObjectClassList>;
    private __list;
    /**
     * Returns a `CustomObjectClass` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.CustomObjectClassesRetrieveRequest} request
     * @param {CustomObjectClasses.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.customObjectClasses.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.CustomObjectClassesRetrieveRequest, requestOptions?: CustomObjectClasses.RequestOptions): core.HttpResponsePromise<Merge.crm.CustomObjectClass>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
