/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace CustomObjects {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class CustomObjects {
    protected readonly _options: CustomObjects.Options;
    constructor(_options: CustomObjects.Options);
    /**
     * Returns a list of `CustomObject` objects.
     *
     * @param {string} customObjectClassId
     * @param {Merge.crm.CustomObjectClassesCustomObjectsListRequest} request
     * @param {CustomObjects.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.customObjects.customObjectClassesCustomObjectsList("custom_object_class_id")
     */
    customObjectClassesCustomObjectsList(customObjectClassId: string, request?: Merge.crm.CustomObjectClassesCustomObjectsListRequest, requestOptions?: CustomObjects.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedCustomObjectList>;
    private __customObjectClassesCustomObjectsList;
    /**
     * Creates a `CustomObject` object with the given values.
     *
     * @param {string} customObjectClassId
     * @param {Merge.crm.CrmCustomObjectEndpointRequest} request
     * @param {CustomObjects.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.customObjects.customObjectClassesCustomObjectsCreate("custom_object_class_id", {
     *         model: {
     *             fields: {
     *                 "test_field": "hello"
     *             }
     *         }
     *     })
     */
    customObjectClassesCustomObjectsCreate(customObjectClassId: string, request: Merge.crm.CrmCustomObjectEndpointRequest, requestOptions?: CustomObjects.RequestOptions): core.HttpResponsePromise<Merge.crm.CrmCustomObjectResponse>;
    private __customObjectClassesCustomObjectsCreate;
    /**
     * Returns a `CustomObject` object with the given `id`.
     *
     * @param {string} customObjectClassId
     * @param {string} id
     * @param {Merge.crm.CustomObjectClassesCustomObjectsRetrieveRequest} request
     * @param {CustomObjects.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.customObjects.customObjectClassesCustomObjectsRetrieve("custom_object_class_id", "id")
     */
    customObjectClassesCustomObjectsRetrieve(customObjectClassId: string, id: string, request?: Merge.crm.CustomObjectClassesCustomObjectsRetrieveRequest, requestOptions?: CustomObjects.RequestOptions): core.HttpResponsePromise<Merge.crm.CustomObject>;
    private __customObjectClassesCustomObjectsRetrieve;
    /**
     * Returns metadata for `CRMCustomObject` POSTs.
     *
     * @param {string} customObjectClassId
     * @param {CustomObjects.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.customObjects.customObjectClassesCustomObjectsMetaPostRetrieve("custom_object_class_id")
     */
    customObjectClassesCustomObjectsMetaPostRetrieve(customObjectClassId: string, requestOptions?: CustomObjects.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __customObjectClassesCustomObjectsMetaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.CustomObjectClassesCustomObjectsRemoteFieldClassesListRequest} request
     * @param {CustomObjects.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.customObjects.customObjectClassesCustomObjectsRemoteFieldClassesList()
     */
    customObjectClassesCustomObjectsRemoteFieldClassesList(request?: Merge.crm.CustomObjectClassesCustomObjectsRemoteFieldClassesListRequest, requestOptions?: CustomObjects.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __customObjectClassesCustomObjectsRemoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
