/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Leads {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Leads {
    protected readonly _options: Leads.Options;
    constructor(_options: Leads.Options);
    /**
     * Returns a list of `Lead` objects.
     *
     * @param {Merge.crm.LeadsListRequest} request
     * @param {Leads.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.leads.list()
     */
    list(request?: Merge.crm.LeadsListRequest, requestOptions?: Leads.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedLeadList>;
    private __list;
    /**
     * Creates a `Lead` object with the given values.
     *
     * @param {Merge.crm.LeadEndpointRequest} request
     * @param {Leads.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.leads.create({
     *         model: {}
     *     })
     */
    create(request: Merge.crm.LeadEndpointRequest, requestOptions?: Leads.RequestOptions): core.HttpResponsePromise<Merge.crm.LeadResponse>;
    private __create;
    /**
     * Returns a `Lead` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.LeadsRetrieveRequest} request
     * @param {Leads.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.leads.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.LeadsRetrieveRequest, requestOptions?: Leads.RequestOptions): core.HttpResponsePromise<Merge.crm.Lead>;
    private __retrieve;
    /**
     * Returns metadata for `Lead` POSTs.
     *
     * @param {Leads.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.leads.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Leads.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.LeadsRemoteFieldClassesListRequest} request
     * @param {Leads.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.leads.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.LeadsRemoteFieldClassesListRequest, requestOptions?: Leads.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
