/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Notes {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Notes {
    protected readonly _options: Notes.Options;
    constructor(_options: Notes.Options);
    /**
     * Returns a list of `Note` objects.
     *
     * @param {Merge.crm.NotesListRequest} request
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.notes.list()
     */
    list(request?: Merge.crm.NotesListRequest, requestOptions?: Notes.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedNoteList>;
    private __list;
    /**
     * Creates a `Note` object with the given values.
     *
     * @param {Merge.crm.NoteEndpointRequest} request
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.notes.create({
     *         model: {}
     *     })
     */
    create(request: Merge.crm.NoteEndpointRequest, requestOptions?: Notes.RequestOptions): core.HttpResponsePromise<Merge.crm.NoteResponse>;
    private __create;
    /**
     * Returns a `Note` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.NotesRetrieveRequest} request
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.notes.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.NotesRetrieveRequest, requestOptions?: Notes.RequestOptions): core.HttpResponsePromise<Merge.crm.Note>;
    private __retrieve;
    /**
     * Returns metadata for `Note` POSTs.
     *
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.notes.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Notes.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.NotesRemoteFieldClassesListRequest} request
     * @param {Notes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.notes.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.NotesRemoteFieldClassesListRequest, requestOptions?: Notes.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
