/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Tasks {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Tasks {
    protected readonly _options: Tasks.Options;
    constructor(_options: Tasks.Options);
    /**
     * Returns a list of `Task` objects.
     *
     * @param {Merge.crm.TasksListRequest} request
     * @param {Tasks.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.tasks.list()
     */
    list(request?: Merge.crm.TasksListRequest, requestOptions?: Tasks.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedTaskList>;
    private __list;
    /**
     * Creates a `Task` object with the given values.
     *
     * @param {Merge.crm.TaskEndpointRequest} request
     * @param {Tasks.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.tasks.create({
     *         model: {}
     *     })
     */
    create(request: Merge.crm.TaskEndpointRequest, requestOptions?: Tasks.RequestOptions): core.HttpResponsePromise<Merge.crm.TaskResponse>;
    private __create;
    /**
     * Returns a `Task` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.TasksRetrieveRequest} request
     * @param {Tasks.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.tasks.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.TasksRetrieveRequest, requestOptions?: Tasks.RequestOptions): core.HttpResponsePromise<Merge.crm.Task>;
    private __retrieve;
    /**
     * Updates a `Task` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.PatchedTaskEndpointRequest} request
     * @param {Tasks.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.tasks.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id: string, request: Merge.crm.PatchedTaskEndpointRequest, requestOptions?: Tasks.RequestOptions): core.HttpResponsePromise<Merge.crm.TaskResponse>;
    private __partialUpdate;
    /**
     * Returns metadata for `Task` PATCHs.
     *
     * @param {string} id
     * @param {Tasks.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.tasks.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id: string, requestOptions?: Tasks.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPatchRetrieve;
    /**
     * Returns metadata for `Task` POSTs.
     *
     * @param {Tasks.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.tasks.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Tasks.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.TasksRemoteFieldClassesListRequest} request
     * @param {Tasks.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.tasks.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.TasksRemoteFieldClassesListRequest, requestOptions?: Tasks.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
