/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Account Object
 * ### Description
 * The `Account` object is used to represent a company in a CRM system.
 * ### Usage Example
 * TODO
 */
export interface Account {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The account's owner. */
    owner?: Merge.crm.AccountOwner;
    /** The account's name. */
    name?: string;
    /** The account's description. */
    description?: string;
    /** The account's industry. */
    industry?: string;
    /** The account's website. */
    website?: string;
    /** The account's number of employees. */
    numberOfEmployees?: number;
    addresses?: Merge.crm.Address[];
    phoneNumbers?: Merge.crm.PhoneNumber[];
    /** The last date (either most recent or furthest in the future) of when an activity occurs in an account. */
    lastActivityAt?: Date;
    /** When the CRM system account data was last modified by a user with a login. */
    remoteUpdatedAt?: Date;
    /** When the third party's account was created. */
    remoteCreatedAt?: Date;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.crm.RemoteData[];
    remoteFields?: Merge.crm.RemoteField[];
}
