/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Note Object
 * ### Description
 * The `Note` object is used to represent a note on another object.
 * ### Usage Example
 * TODO
 */
export interface Note {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The note's owner. */
    owner?: Merge.crm.NoteOwner;
    /** The note's content. */
    content?: string;
    /** The note's contact. */
    contact?: Merge.crm.NoteContact;
    /** The note's account. */
    account?: Merge.crm.NoteAccount;
    /** The note's opportunity. */
    opportunity?: Merge.crm.NoteOpportunity;
    /** When the third party's lead was updated. */
    remoteUpdatedAt?: Date;
    /** When the third party's lead was created. */
    remoteCreatedAt?: Date;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.crm.RemoteData[];
    remoteFields?: Merge.crm.RemoteField[];
}
