/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Drives {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Drives {
    protected readonly _options: Drives.Options;
    constructor(_options: Drives.Options);
    /**
     * Returns a list of `Drive` objects.
     *
     * @param {Merge.filestorage.DrivesListRequest} request
     * @param {Drives.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.drives.list()
     */
    list(request?: Merge.filestorage.DrivesListRequest, requestOptions?: Drives.RequestOptions): core.HttpResponsePromise<Merge.filestorage.PaginatedDriveList>;
    private __list;
    /**
     * Returns a `Drive` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.filestorage.DrivesRetrieveRequest} request
     * @param {Drives.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.drives.retrieve("id")
     */
    retrieve(id: string, request?: Merge.filestorage.DrivesRetrieveRequest, requestOptions?: Drives.RequestOptions): core.HttpResponsePromise<Merge.filestorage.Drive>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
