/**
 * This file was auto-generated by Fern from our API Definition.
 */
/**
 * @example
 *     {
 *         targetFieldName: "example_target_field_name",
 *         targetFieldDescription: "this is a example description of the target field",
 *         remoteFieldTraversalPath: ["example_remote_field"],
 *         remoteMethod: "GET",
 *         remoteUrlPath: "/example-url-path",
 *         commonModelName: "ExampleCommonModel"
 *     }
 */
export interface CreateFieldMappingRequest {
    /**
     * If `true`, remote fields metadata is excluded from each field mapping instance (i.e. `remote_fields.remote_key_name` and `remote_fields.schema` will be null). This will increase the speed of the request since these fields require some calculations.
     */
    excludeRemoteFieldMetadata?: boolean;
    /** The name of the target field you want this remote field to map to. */
    targetFieldName: string;
    /** The description of the target field you want this remote field to map to. */
    targetFieldDescription: string;
    /** The field traversal path of the remote field listed when you hit the GET /remote-fields endpoint. */
    remoteFieldTraversalPath: unknown[];
    /** The method of the remote endpoint where the remote field is coming from. */
    remoteMethod: string;
    /** The path of the remote endpoint where the remote field is coming from. */
    remoteUrlPath: string;
    /** The name of the Common Model that the remote field corresponds to in a given category. */
    commonModelName: string;
}
