/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Folders {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Folders {
    protected readonly _options: Folders.Options;
    constructor(_options: Folders.Options);
    /**
     * Returns a list of `Folder` objects.
     *
     * @param {Merge.filestorage.FoldersListRequest} request
     * @param {Folders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.folders.list()
     */
    list(request?: Merge.filestorage.FoldersListRequest, requestOptions?: Folders.RequestOptions): core.HttpResponsePromise<Merge.filestorage.PaginatedFolderList>;
    private __list;
    /**
     * Creates a `Folder` object with the given values.
     *
     * @param {Merge.filestorage.FileStorageFolderEndpointRequest} request
     * @param {Folders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.folders.create({
     *         model: {}
     *     })
     */
    create(request: Merge.filestorage.FileStorageFolderEndpointRequest, requestOptions?: Folders.RequestOptions): core.HttpResponsePromise<Merge.filestorage.FileStorageFolderResponse>;
    private __create;
    /**
     * Returns a `Folder` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.filestorage.FoldersRetrieveRequest} request
     * @param {Folders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.folders.retrieve("id")
     */
    retrieve(id: string, request?: Merge.filestorage.FoldersRetrieveRequest, requestOptions?: Folders.RequestOptions): core.HttpResponsePromise<Merge.filestorage.Folder>;
    private __retrieve;
    /**
     * Returns metadata for `FileStorageFolder` POSTs.
     *
     * @param {Folders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.folders.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Folders.RequestOptions): core.HttpResponsePromise<Merge.filestorage.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
