/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Issues {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Issues {
    protected readonly _options: Issues.Options;
    constructor(_options: Issues.Options);
    /**
     * Gets all issues for Organization.
     *
     * @param {Merge.filestorage.IssuesListRequest} request
     * @param {Issues.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.issues.list()
     */
    list(request?: Merge.filestorage.IssuesListRequest, requestOptions?: Issues.RequestOptions): core.HttpResponsePromise<Merge.filestorage.PaginatedIssueList>;
    private __list;
    /**
     * Get a specific issue.
     *
     * @param {string} id
     * @param {Issues.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.issues.retrieve("id")
     */
    retrieve(id: string, requestOptions?: Issues.RequestOptions): core.HttpResponsePromise<Merge.filestorage.Issue>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
