/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Users {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Users {
    protected readonly _options: Users.Options;
    constructor(_options: Users.Options);
    /**
     * Returns a list of `User` objects.
     *
     * @param {Merge.filestorage.UsersListRequest} request
     * @param {Users.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.users.list()
     */
    list(request?: Merge.filestorage.UsersListRequest, requestOptions?: Users.RequestOptions): core.HttpResponsePromise<Merge.filestorage.PaginatedUserList>;
    private __list;
    /**
     * Returns a `User` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.filestorage.UsersRetrieveRequest} request
     * @param {Users.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.filestorage.users.retrieve("id")
     */
    retrieve(id: string, request?: Merge.filestorage.UsersRetrieveRequest, requestOptions?: Users.RequestOptions): core.HttpResponsePromise<Merge.filestorage.User>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
