/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Employments {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Employments {
    protected readonly _options: Employments.Options;
    constructor(_options: Employments.Options);
    /**
     * Returns a list of `Employment` objects.
     *
     * @param {Merge.hris.EmploymentsListRequest} request
     * @param {Employments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.employments.list()
     */
    list(request?: Merge.hris.EmploymentsListRequest, requestOptions?: Employments.RequestOptions): core.HttpResponsePromise<Merge.hris.PaginatedEmploymentList>;
    private __list;
    /**
     * Returns an `Employment` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.hris.EmploymentsRetrieveRequest} request
     * @param {Employments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.employments.retrieve("id")
     */
    retrieve(id: string, request?: Merge.hris.EmploymentsRetrieveRequest, requestOptions?: Employments.RequestOptions): core.HttpResponsePromise<Merge.hris.Employment>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
