/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Groups {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Groups {
    protected readonly _options: Groups.Options;
    constructor(_options: Groups.Options);
    /**
     * Returns a list of `Group` objects.
     *
     * @param {Merge.hris.GroupsListRequest} request
     * @param {Groups.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.groups.list()
     */
    list(request?: Merge.hris.GroupsListRequest, requestOptions?: Groups.RequestOptions): core.HttpResponsePromise<Merge.hris.PaginatedGroupList>;
    private __list;
    /**
     * Returns a `Group` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.hris.GroupsRetrieveRequest} request
     * @param {Groups.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.groups.retrieve("id")
     */
    retrieve(id: string, request?: Merge.hris.GroupsRetrieveRequest, requestOptions?: Groups.RequestOptions): core.HttpResponsePromise<Merge.hris.Group>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
