/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Scopes {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Scopes {
    protected readonly _options: Scopes.Options;
    constructor(_options: Scopes.Options);
    /**
     * Get the default permissions for Merge Common Models and fields across all Linked Accounts of a given category. [Learn more](https://help.merge.dev/en/articles/5950052-common-model-and-field-scopes).
     *
     * @param {Scopes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.scopes.defaultScopesRetrieve()
     */
    defaultScopesRetrieve(requestOptions?: Scopes.RequestOptions): core.HttpResponsePromise<Merge.hris.CommonModelScopeApi>;
    private __defaultScopesRetrieve;
    /**
     * Get all available permissions for Merge Common Models and fields for a single Linked Account. [Learn more](https://help.merge.dev/en/articles/5950052-common-model-and-field-scopes).
     *
     * @param {Scopes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.scopes.linkedAccountScopesRetrieve()
     */
    linkedAccountScopesRetrieve(requestOptions?: Scopes.RequestOptions): core.HttpResponsePromise<Merge.hris.CommonModelScopeApi>;
    private __linkedAccountScopesRetrieve;
    /**
     * Update permissions for any Common Model or field for a single Linked Account. Any Scopes not set in this POST request will inherit the default Scopes. [Learn more](https://help.merge.dev/en/articles/5950052-common-model-and-field-scopes)
     *
     * @param {Merge.hris.LinkedAccountCommonModelScopeDeserializerRequest} request
     * @param {Scopes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.scopes.linkedAccountScopesCreate({
     *         commonModels: [{
     *                 modelName: "Employee",
     *                 modelPermissions: {
     *                     "READ": {
     *                         isEnabled: true
     *                     },
     *                     "WRITE": {
     *                         isEnabled: false
     *                     }
     *                 },
     *                 fieldPermissions: {
     *                     enabledFields: ["avatar", "home_location"],
     *                     disabledFields: ["work_location"]
     *                 }
     *             }, {
     *                 modelName: "Benefit",
     *                 modelPermissions: {
     *                     "WRITE": {
     *                         isEnabled: false
     *                     }
     *                 }
     *             }]
     *     })
     */
    linkedAccountScopesCreate(request: Merge.hris.LinkedAccountCommonModelScopeDeserializerRequest, requestOptions?: Scopes.RequestOptions): core.HttpResponsePromise<Merge.hris.CommonModelScopeApi>;
    private __linkedAccountScopesCreate;
    protected _getAuthorizationHeader(): Promise<string>;
}
