/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Teams {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Teams {
    protected readonly _options: Teams.Options;
    constructor(_options: Teams.Options);
    /**
     * Returns a list of `Team` objects.
     *
     * @param {Merge.hris.TeamsListRequest} request
     * @param {Teams.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.teams.list()
     */
    list(request?: Merge.hris.TeamsListRequest, requestOptions?: Teams.RequestOptions): core.HttpResponsePromise<Merge.hris.PaginatedTeamList>;
    private __list;
    /**
     * Returns a `Team` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.hris.TeamsRetrieveRequest} request
     * @param {Teams.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.teams.retrieve("id")
     */
    retrieve(id: string, request?: Merge.hris.TeamsRetrieveRequest, requestOptions?: Teams.RequestOptions): core.HttpResponsePromise<Merge.hris.Team>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
