/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace TimesheetEntries {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class TimesheetEntries {
    protected readonly _options: TimesheetEntries.Options;
    constructor(_options: TimesheetEntries.Options);
    /**
     * Returns a list of `TimesheetEntry` objects.
     *
     * @param {Merge.hris.TimesheetEntriesListRequest} request
     * @param {TimesheetEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timesheetEntries.list()
     */
    list(request?: Merge.hris.TimesheetEntriesListRequest, requestOptions?: TimesheetEntries.RequestOptions): core.HttpResponsePromise<Merge.hris.PaginatedTimesheetEntryList>;
    private __list;
    /**
     * Creates a `TimesheetEntry` object with the given values.
     *
     * @param {Merge.hris.TimesheetEntryEndpointRequest} request
     * @param {TimesheetEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timesheetEntries.create({
     *         model: {}
     *     })
     */
    create(request: Merge.hris.TimesheetEntryEndpointRequest, requestOptions?: TimesheetEntries.RequestOptions): core.HttpResponsePromise<Merge.hris.TimesheetEntryResponse>;
    private __create;
    /**
     * Returns a `TimesheetEntry` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.hris.TimesheetEntriesRetrieveRequest} request
     * @param {TimesheetEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timesheetEntries.retrieve("id")
     */
    retrieve(id: string, request?: Merge.hris.TimesheetEntriesRetrieveRequest, requestOptions?: TimesheetEntries.RequestOptions): core.HttpResponsePromise<Merge.hris.TimesheetEntry>;
    private __retrieve;
    /**
     * Returns metadata for `TimesheetEntry` POSTs.
     *
     * @param {TimesheetEntries.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timesheetEntries.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: TimesheetEntries.RequestOptions): core.HttpResponsePromise<Merge.hris.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
