/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Earning Object
 * ### Description
 * The `Earning` object is used to represent an array of different compensations that an employee receives within specific wage categories.
 *
 * ### Usage Example
 * Fetch from the `LIST Earnings` endpoint and filter by `ID` to show all earnings.
 */
export interface Earning {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    employeePayrollRun?: string;
    /** The amount earned. */
    amount?: number;
    /**
     * The type of earning.
     *
     * * `SALARY` - SALARY
     * * `REIMBURSEMENT` - REIMBURSEMENT
     * * `OVERTIME` - OVERTIME
     * * `BONUS` - BONUS
     */
    type?: Merge.hris.EarningType;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.hris.RemoteData[];
}
