/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The EmployerBenefit Object
 * ### Description
 * The `Employer Benefit` object is used to represent a benefit plan offered by a company.
 *
 * ### Usage Example
 * Fetch from the `LIST EmployerBenefits` endpoint and filter by `ID` to show all EmployerBenefits.
 */
export interface EmployerBenefit {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /**
     * The type of benefit plan.
     *
     * * `MEDICAL` - MEDICAL
     * * `HEALTH_SAVINGS` - HEALTH_SAVINGS
     * * `INSURANCE` - INSURANCE
     * * `RETIREMENT` - RETIREMENT
     * * `OTHER` - OTHER
     */
    benefitPlanType?: Merge.hris.EmployerBenefitBenefitPlanType;
    /** The employer benefit's name - typically the carrier or network name. */
    name?: string;
    /** The employer benefit's description. */
    description?: string;
    /** The employer benefit's deduction code. */
    deductionCode?: string;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.hris.RemoteData[];
}
