/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Tax Object
 * ### Description
 * The `Tax` object is used to represent an array of the tax deductions for a given employee's payroll run.
 *
 * ### Usage Example
 * Fetch from the `LIST Taxes` endpoint and filter by `ID` to show all taxes.
 */
export interface Tax {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    employeePayrollRun?: string;
    /** The tax's name. */
    name?: string;
    /** The tax amount. */
    amount?: number;
    /** Whether or not the employer is responsible for paying the tax. */
    employerTax?: boolean;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.hris.RemoteData[];
}
