/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Timesheet Entry Object
 * ### Description
 * The `Timesheet Entry` object is used to track coverage for hours worked by an 'Employee'.
 *
 *
 * ### Usage Example
 * GET and POST Timesheet Entries
 */
export interface TimesheetEntry {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The employee the timesheet entry is for. */
    employee?: Merge.hris.TimesheetEntryEmployee;
    /** The number of hours logged by the employee. */
    hoursWorked?: number;
    /** The time at which the employee started work. */
    startTime?: Date;
    /** The time at which the employee ended work. */
    endTime?: Date;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.hris.RemoteData[];
}
