/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Accounts {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Accounts {
    protected readonly _options: Accounts.Options;
    constructor(_options: Accounts.Options);
    /**
     * Returns a list of `Account` objects.
     *
     * @param {Merge.ticketing.AccountsListRequest} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.accounts.list()
     */
    list(request?: Merge.ticketing.AccountsListRequest, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedAccountList>;
    private __list;
    /**
     * Returns an `Account` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ticketing.AccountsRetrieveRequest} request
     * @param {Accounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.accounts.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ticketing.AccountsRetrieveRequest, requestOptions?: Accounts.RequestOptions): core.HttpResponsePromise<Merge.ticketing.Account>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
