/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Comments {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Comments {
    protected readonly _options: Comments.Options;
    constructor(_options: Comments.Options);
    /**
     * Returns a list of `Comment` objects.
     *
     * @param {Merge.ticketing.CommentsListRequest} request
     * @param {Comments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.comments.list()
     */
    list(request?: Merge.ticketing.CommentsListRequest, requestOptions?: Comments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedCommentList>;
    private __list;
    /**
     * Creates a `Comment` object with the given values.
     *
     * @param {Merge.ticketing.CommentEndpointRequest} request
     * @param {Comments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.comments.create({
     *         model: {}
     *     })
     */
    create(request: Merge.ticketing.CommentEndpointRequest, requestOptions?: Comments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.CommentResponse>;
    private __create;
    /**
     * Returns a `Comment` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ticketing.CommentsRetrieveRequest} request
     * @param {Comments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.comments.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ticketing.CommentsRetrieveRequest, requestOptions?: Comments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.Comment>;
    private __retrieve;
    /**
     * Returns metadata for `Comment` POSTs.
     *
     * @param {Comments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.comments.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Comments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
