/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Contacts {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Contacts {
    protected readonly _options: Contacts.Options;
    constructor(_options: Contacts.Options);
    /**
     * Returns a list of `Contact` objects.
     *
     * @param {Merge.ticketing.ContactsListRequest} request
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.contacts.list()
     */
    list(request?: Merge.ticketing.ContactsListRequest, requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedContactList>;
    private __list;
    /**
     * Creates a `Contact` object with the given values.
     *
     * @param {Merge.ticketing.TicketingContactEndpointRequest} request
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.contacts.create({
     *         model: {}
     *     })
     */
    create(request: Merge.ticketing.TicketingContactEndpointRequest, requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.ticketing.TicketingContactResponse>;
    private __create;
    /**
     * Returns a `Contact` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ticketing.ContactsRetrieveRequest} request
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.contacts.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ticketing.ContactsRetrieveRequest, requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.ticketing.Contact>;
    private __retrieve;
    /**
     * Returns metadata for `TicketingContact` POSTs.
     *
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.contacts.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.ticketing.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
