/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace RegenerateKey {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class RegenerateKey {
    protected readonly _options: RegenerateKey.Options;
    constructor(_options: RegenerateKey.Options);
    /**
     * Exchange remote keys.
     *
     * @param {Merge.ticketing.RemoteKeyForRegenerationRequest} request
     * @param {RegenerateKey.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.regenerateKey.create({
     *         name: "Remote Deployment Key 1"
     *     })
     */
    create(request: Merge.ticketing.RemoteKeyForRegenerationRequest, requestOptions?: RegenerateKey.RequestOptions): core.HttpResponsePromise<Merge.ticketing.RemoteKey>;
    private __create;
    protected _getAuthorizationHeader(): Promise<string>;
}
