/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace WebhookReceivers {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class WebhookReceivers {
    protected readonly _options: WebhookReceivers.Options;
    constructor(_options: WebhookReceivers.Options);
    /**
     * Returns a list of `WebhookReceiver` objects.
     *
     * @param {WebhookReceivers.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.webhookReceivers.list()
     */
    list(requestOptions?: WebhookReceivers.RequestOptions): core.HttpResponsePromise<Merge.ticketing.WebhookReceiver[]>;
    private __list;
    /**
     * Creates a `WebhookReceiver` object with the given values.
     *
     * @param {Merge.ticketing.WebhookReceiverRequest} request
     * @param {WebhookReceivers.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.webhookReceivers.create({
     *         event: "event",
     *         isActive: true
     *     })
     */
    create(request: Merge.ticketing.WebhookReceiverRequest, requestOptions?: WebhookReceivers.RequestOptions): core.HttpResponsePromise<Merge.ticketing.WebhookReceiver>;
    private __create;
    protected _getAuthorizationHeader(): Promise<string>;
}
