/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Attachment Object
 * ### Description
 * The `Attachment` object is used to represent an attachment for a ticket.
 *
 * ### Usage Example
 * TODO
 */
export interface Attachment {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The attachment's name. It is required to include the file extension in the attachment's name. */
    fileName?: string;
    /** The ticket associated with the attachment. */
    ticket?: Merge.ticketing.AttachmentTicket;
    /** The attachment's url. It is required to include the file extension in the file's URL. */
    fileUrl?: string;
    /** The attachment's file format. */
    contentType?: string;
    /** The user who uploaded the attachment. */
    uploadedBy?: string;
    /** When the third party's attachment was created. */
    remoteCreatedAt?: Date;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.ticketing.RemoteData[];
}
