/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Comment Object
 * ### Description
 * The `Comment` object is used to represent a comment on a ticket.
 *
 * ### Usage Example
 * TODO
 */
export interface CommentRequest {
    /** The author of the Comment, if the author is a User. If the third party does not support specifying an author, we will append "[Posted on behalf of {name}]" to the comment. */
    user?: Merge.ticketing.CommentRequestUser;
    /** The author of the Comment, if the author is a Contact.If the third party does not support specifying an author, we will append "[Posted on behalf of {name}]" to the comment. */
    contact?: Merge.ticketing.CommentRequestContact;
    /** The comment's text body. */
    body?: string;
    /** The comment's text body formatted as html. */
    htmlBody?: string;
    /** The ticket associated with the comment. */
    ticket?: Merge.ticketing.CommentRequestTicket;
    /** Whether or not the comment is internal. */
    isPrivate?: boolean;
    integrationParams?: Record<string, unknown>;
    linkedAccountParams?: Record<string, unknown>;
}
