/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace AccountingPeriods {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class AccountingPeriods {
    protected readonly _options: AccountingPeriods.Options;
    constructor(_options: AccountingPeriods.Options);
    /**
     * Returns a list of `AccountingPeriod` objects.
     *
     * @param {Merge.accounting.AccountingPeriodsListRequest} request
     * @param {AccountingPeriods.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.accountingPeriods.list()
     */
    list(request?: Merge.accounting.AccountingPeriodsListRequest, requestOptions?: AccountingPeriods.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedAccountingPeriodList>;
    private __list;
    /**
     * Returns an `AccountingPeriod` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.AccountingPeriodsRetrieveRequest} request
     * @param {AccountingPeriods.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.accountingPeriods.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.AccountingPeriodsRetrieveRequest, requestOptions?: AccountingPeriods.RequestOptions): core.HttpResponsePromise<Merge.accounting.AccountingPeriod>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
