/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Attachments {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Attachments {
    protected readonly _options: Attachments.Options;
    constructor(_options: Attachments.Options);
    /**
     * Returns a list of `AccountingAttachment` objects.
     *
     * @param {Merge.accounting.AttachmentsListRequest} request
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.attachments.list()
     */
    list(request?: Merge.accounting.AttachmentsListRequest, requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedAccountingAttachmentList>;
    private __list;
    /**
     * Creates an `AccountingAttachment` object with the given values.
     *
     * @param {Merge.accounting.AccountingAttachmentEndpointRequest} request
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.attachments.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.AccountingAttachmentEndpointRequest, requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.accounting.AccountingAttachmentResponse>;
    private __create;
    /**
     * Returns an `AccountingAttachment` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.AttachmentsRetrieveRequest} request
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.attachments.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.AttachmentsRetrieveRequest, requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.accounting.AccountingAttachment>;
    private __retrieve;
    /**
     * Returns metadata for `AccountingAttachment` POSTs.
     *
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.attachments.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
