/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace BankFeedAccounts {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class BankFeedAccounts {
    protected readonly _options: BankFeedAccounts.Options;
    constructor(_options: BankFeedAccounts.Options);
    /**
     * Returns a list of `BankFeedAccount` objects.
     *
     * @param {Merge.accounting.BankFeedAccountsListRequest} request
     * @param {BankFeedAccounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedAccounts.list()
     */
    list(request?: Merge.accounting.BankFeedAccountsListRequest, requestOptions?: BankFeedAccounts.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedBankFeedAccountList>;
    private __list;
    /**
     * Creates a `BankFeedAccount` object with the given values.
     *
     * @param {Merge.accounting.BankFeedAccountEndpointRequest} request
     * @param {BankFeedAccounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedAccounts.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.BankFeedAccountEndpointRequest, requestOptions?: BankFeedAccounts.RequestOptions): core.HttpResponsePromise<Merge.accounting.BankFeedAccountResponse>;
    private __create;
    /**
     * Returns a `BankFeedAccount` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.BankFeedAccountsRetrieveRequest} request
     * @param {BankFeedAccounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedAccounts.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.BankFeedAccountsRetrieveRequest, requestOptions?: BankFeedAccounts.RequestOptions): core.HttpResponsePromise<Merge.accounting.BankFeedAccount>;
    private __retrieve;
    /**
     * Returns metadata for `BankFeedAccount` POSTs.
     *
     * @param {BankFeedAccounts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.bankFeedAccounts.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: BankFeedAccounts.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
