/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace CompanyInfo {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class CompanyInfo {
    protected readonly _options: CompanyInfo.Options;
    constructor(_options: CompanyInfo.Options);
    /**
     * Returns a list of `CompanyInfo` objects.
     *
     * @param {Merge.accounting.CompanyInfoListRequest} request
     * @param {CompanyInfo.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.companyInfo.list()
     */
    list(request?: Merge.accounting.CompanyInfoListRequest, requestOptions?: CompanyInfo.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedCompanyInfoList>;
    private __list;
    /**
     * Returns a `CompanyInfo` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.CompanyInfoRetrieveRequest} request
     * @param {CompanyInfo.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.companyInfo.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.CompanyInfoRetrieveRequest, requestOptions?: CompanyInfo.RequestOptions): core.HttpResponsePromise<Merge.accounting.CompanyInfo>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
