/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Contacts {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Contacts {
    protected readonly _options: Contacts.Options;
    constructor(_options: Contacts.Options);
    /**
     * Returns a list of `Contact` objects.
     *
     * @param {Merge.accounting.ContactsListRequest} request
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.contacts.list()
     */
    list(request?: Merge.accounting.ContactsListRequest, requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedContactList>;
    private __list;
    /**
     * Creates a `Contact` object with the given values.
     *
     * @param {Merge.accounting.ContactEndpointRequest} request
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.contacts.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.ContactEndpointRequest, requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.accounting.ContactResponse>;
    private __create;
    /**
     * Returns a `Contact` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.ContactsRetrieveRequest} request
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.contacts.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.ContactsRetrieveRequest, requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.accounting.Contact>;
    private __retrieve;
    /**
     * Returns metadata for `Contact` POSTs.
     *
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.contacts.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.ContactsRemoteFieldClassesListRequest} request
     * @param {Contacts.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.contacts.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.accounting.ContactsRemoteFieldClassesListRequest, requestOptions?: Contacts.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
