/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
export declare namespace DeleteAccount {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class DeleteAccount {
    protected readonly _options: DeleteAccount.Options;
    constructor(_options: DeleteAccount.Options);
    /**
     * Delete a linked account.
     *
     * @param {DeleteAccount.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.deleteAccount.delete()
     */
    delete(requestOptions?: DeleteAccount.RequestOptions): core.HttpResponsePromise<void>;
    private __delete;
    protected _getAuthorizationHeader(): Promise<string>;
}
