"use strict";
/**
 * This file was auto-generated by Fern from our API Definition.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Invoices = void 0;
const environments = __importStar(require("../../../../../../environments"));
const core = __importStar(require("../../../../../../core"));
const serializers = __importStar(require("../../../../../../serialization/index"));
const url_join_1 = __importDefault(require("url-join"));
const errors = __importStar(require("../../../../../../errors/index"));
class Invoices {
    constructor(_options) {
        this._options = _options;
    }
    /**
     * Returns a list of `Invoice` objects.
     *
     * @param {Merge.accounting.InvoicesListRequest} request
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.list()
     */
    list(request = {}, requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__list(request, requestOptions));
    }
    __list() {
        return __awaiter(this, arguments, void 0, function* (request = {}, requestOptions) {
            var _a, _b, _c;
            const { companyId, contactId, createdAfter, createdBefore, cursor, expand, includeDeletedData, includeRemoteData, includeRemoteFields, includeShellData, issueDateAfter, issueDateBefore, modifiedAfter, modifiedBefore, number: number_, pageSize, remoteFields, remoteId, showEnumOrigins, status, type: type_, } = request;
            const _queryParams = {};
            if (companyId != null) {
                _queryParams["company_id"] = companyId;
            }
            if (contactId != null) {
                _queryParams["contact_id"] = contactId;
            }
            if (createdAfter != null) {
                _queryParams["created_after"] = createdAfter.toISOString();
            }
            if (createdBefore != null) {
                _queryParams["created_before"] = createdBefore.toISOString();
            }
            if (cursor != null) {
                _queryParams["cursor"] = cursor;
            }
            if (expand != null) {
                _queryParams["expand"] = serializers.accounting.InvoicesListRequestExpand.jsonOrThrow(expand, {
                    unrecognizedObjectKeys: "strip",
                });
            }
            if (includeDeletedData != null) {
                _queryParams["include_deleted_data"] = includeDeletedData.toString();
            }
            if (includeRemoteData != null) {
                _queryParams["include_remote_data"] = includeRemoteData.toString();
            }
            if (includeRemoteFields != null) {
                _queryParams["include_remote_fields"] = includeRemoteFields.toString();
            }
            if (includeShellData != null) {
                _queryParams["include_shell_data"] = includeShellData.toString();
            }
            if (issueDateAfter != null) {
                _queryParams["issue_date_after"] = issueDateAfter.toISOString();
            }
            if (issueDateBefore != null) {
                _queryParams["issue_date_before"] = issueDateBefore.toISOString();
            }
            if (modifiedAfter != null) {
                _queryParams["modified_after"] = modifiedAfter.toISOString();
            }
            if (modifiedBefore != null) {
                _queryParams["modified_before"] = modifiedBefore.toISOString();
            }
            if (number_ != null) {
                _queryParams["number"] = number_;
            }
            if (pageSize != null) {
                _queryParams["page_size"] = pageSize.toString();
            }
            if (remoteFields != null) {
                _queryParams["remote_fields"] = remoteFields;
            }
            if (remoteId != null) {
                _queryParams["remote_id"] = remoteId;
            }
            if (showEnumOrigins != null) {
                _queryParams["show_enum_origins"] = showEnumOrigins;
            }
            if (status != null) {
                _queryParams["status"] = serializers.accounting.InvoicesListRequestStatus.jsonOrThrow(status, {
                    unrecognizedObjectKeys: "strip",
                });
            }
            if (type_ != null) {
                _queryParams["type"] = serializers.accounting.InvoicesListRequestType.jsonOrThrow(type_, {
                    unrecognizedObjectKeys: "strip",
                });
            }
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, "accounting/v1/invoices"),
                method: "GET",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                queryParameters: _queryParams,
                requestType: "json",
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.PaginatedInvoiceList.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling GET /accounting/v1/invoices.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * Creates an `Invoice` object with the given values.
     *             Including a `PurchaseOrder` id in the `purchase_orders` property will generate an Accounts Payable Invoice from the specified Purchase Order(s).
     *
     *
     * @param {Merge.accounting.InvoiceEndpointRequest} request
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.create({
     *         model: {}
     *     })
     */
    create(request, requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__create(request, requestOptions));
    }
    __create(request, requestOptions) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            const { isDebugMode, runAsync } = request, _body = __rest(request, ["isDebugMode", "runAsync"]);
            const _queryParams = {};
            if (isDebugMode != null) {
                _queryParams["is_debug_mode"] = isDebugMode.toString();
            }
            if (runAsync != null) {
                _queryParams["run_async"] = runAsync.toString();
            }
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, "accounting/v1/invoices"),
                method: "POST",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                queryParameters: _queryParams,
                requestType: "json",
                body: serializers.accounting.InvoiceEndpointRequest.jsonOrThrow(_body, { unrecognizedObjectKeys: "strip" }),
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.InvoiceResponse.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling POST /accounting/v1/invoices.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * Returns an `Invoice` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.InvoicesRetrieveRequest} request
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.retrieve("id")
     */
    retrieve(id, request = {}, requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__retrieve(id, request, requestOptions));
    }
    __retrieve(id_1) {
        return __awaiter(this, arguments, void 0, function* (id, request = {}, requestOptions) {
            var _a, _b, _c;
            const { expand, includeRemoteData, includeRemoteFields, includeShellData, remoteFields, showEnumOrigins } = request;
            const _queryParams = {};
            if (expand != null) {
                _queryParams["expand"] = serializers.accounting.InvoicesRetrieveRequestExpand.jsonOrThrow(expand, {
                    unrecognizedObjectKeys: "strip",
                });
            }
            if (includeRemoteData != null) {
                _queryParams["include_remote_data"] = includeRemoteData.toString();
            }
            if (includeRemoteFields != null) {
                _queryParams["include_remote_fields"] = includeRemoteFields.toString();
            }
            if (includeShellData != null) {
                _queryParams["include_shell_data"] = includeShellData.toString();
            }
            if (remoteFields != null) {
                _queryParams["remote_fields"] = remoteFields;
            }
            if (showEnumOrigins != null) {
                _queryParams["show_enum_origins"] = showEnumOrigins;
            }
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, `accounting/v1/invoices/${encodeURIComponent(id)}`),
                method: "GET",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                queryParameters: _queryParams,
                requestType: "json",
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.Invoice.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling GET /accounting/v1/invoices/{id}.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * Updates an `Invoice` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PatchedInvoiceEndpointRequest} request
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id, request, requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__partialUpdate(id, request, requestOptions));
    }
    __partialUpdate(id, request, requestOptions) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            const { isDebugMode, runAsync } = request, _body = __rest(request, ["isDebugMode", "runAsync"]);
            const _queryParams = {};
            if (isDebugMode != null) {
                _queryParams["is_debug_mode"] = isDebugMode.toString();
            }
            if (runAsync != null) {
                _queryParams["run_async"] = runAsync.toString();
            }
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, `accounting/v1/invoices/${encodeURIComponent(id)}`),
                method: "PATCH",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                queryParameters: _queryParams,
                requestType: "json",
                body: serializers.accounting.PatchedInvoiceEndpointRequest.jsonOrThrow(_body, {
                    unrecognizedObjectKeys: "strip",
                }),
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.InvoiceResponse.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling PATCH /accounting/v1/invoices/{id}.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.InvoicesLineItemsRemoteFieldClassesListRequest} request
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.lineItemsRemoteFieldClassesList()
     */
    lineItemsRemoteFieldClassesList(request = {}, requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__lineItemsRemoteFieldClassesList(request, requestOptions));
    }
    __lineItemsRemoteFieldClassesList() {
        return __awaiter(this, arguments, void 0, function* (request = {}, requestOptions) {
            var _a, _b, _c;
            const { cursor, includeDeletedData, includeRemoteData, includeShellData, isCommonModelField, pageSize } = request;
            const _queryParams = {};
            if (cursor != null) {
                _queryParams["cursor"] = cursor;
            }
            if (includeDeletedData != null) {
                _queryParams["include_deleted_data"] = includeDeletedData.toString();
            }
            if (includeRemoteData != null) {
                _queryParams["include_remote_data"] = includeRemoteData.toString();
            }
            if (includeShellData != null) {
                _queryParams["include_shell_data"] = includeShellData.toString();
            }
            if (isCommonModelField != null) {
                _queryParams["is_common_model_field"] = isCommonModelField.toString();
            }
            if (pageSize != null) {
                _queryParams["page_size"] = pageSize.toString();
            }
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, "accounting/v1/invoices/line-items/remote-field-classes"),
                method: "GET",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                queryParameters: _queryParams,
                requestType: "json",
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.PaginatedRemoteFieldClassList.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling GET /accounting/v1/invoices/line-items/remote-field-classes.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * Returns metadata for `Invoice` PATCHs.
     *
     * @param {string} id
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id, requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__metaPatchRetrieve(id, requestOptions));
    }
    __metaPatchRetrieve(id, requestOptions) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, `accounting/v1/invoices/meta/patch/${encodeURIComponent(id)}`),
                method: "GET",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                requestType: "json",
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.MetaResponse.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling GET /accounting/v1/invoices/meta/patch/{id}.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * Returns metadata for `Invoice` POSTs.
     *
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__metaPostRetrieve(requestOptions));
    }
    __metaPostRetrieve(requestOptions) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, "accounting/v1/invoices/meta/post"),
                method: "GET",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                requestType: "json",
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.MetaResponse.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling GET /accounting/v1/invoices/meta/post.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.InvoicesRemoteFieldClassesListRequest} request
     * @param {Invoices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.invoices.remoteFieldClassesList()
     */
    remoteFieldClassesList(request = {}, requestOptions) {
        return core.HttpResponsePromise.fromPromise(this.__remoteFieldClassesList(request, requestOptions));
    }
    __remoteFieldClassesList() {
        return __awaiter(this, arguments, void 0, function* (request = {}, requestOptions) {
            var _a, _b, _c;
            const { cursor, includeDeletedData, includeRemoteData, includeShellData, isCommonModelField, pageSize } = request;
            const _queryParams = {};
            if (cursor != null) {
                _queryParams["cursor"] = cursor;
            }
            if (includeDeletedData != null) {
                _queryParams["include_deleted_data"] = includeDeletedData.toString();
            }
            if (includeRemoteData != null) {
                _queryParams["include_remote_data"] = includeRemoteData.toString();
            }
            if (includeShellData != null) {
                _queryParams["include_shell_data"] = includeShellData.toString();
            }
            if (isCommonModelField != null) {
                _queryParams["is_common_model_field"] = isCommonModelField.toString();
            }
            if (pageSize != null) {
                _queryParams["page_size"] = pageSize.toString();
            }
            const _response = yield ((_a = this._options.fetcher) !== null && _a !== void 0 ? _a : core.fetcher)({
                url: (0, url_join_1.default)((_c = (_b = (yield core.Supplier.get(this._options.baseUrl))) !== null && _b !== void 0 ? _b : (yield core.Supplier.get(this._options.environment))) !== null && _c !== void 0 ? _c : environments.MergeEnvironment.Production, "accounting/v1/invoices/remote-field-classes"),
                method: "GET",
                headers: Object.assign({ Authorization: yield this._getAuthorizationHeader(), "X-Account-Token": (yield core.Supplier.get(this._options.accountToken)) != null
                        ? yield core.Supplier.get(this._options.accountToken)
                        : undefined, "X-Fern-Language": "JavaScript", "X-Fern-SDK-Name": "@mergeapi/merge-node-client", "X-Fern-SDK-Version": "1.1.8", "User-Agent": "@mergeapi/merge-node-client/1.1.8", "X-Fern-Runtime": core.RUNTIME.type, "X-Fern-Runtime-Version": core.RUNTIME.version }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers),
                contentType: "application/json",
                queryParameters: _queryParams,
                requestType: "json",
                timeoutMs: (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000,
                maxRetries: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries,
                abortSignal: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal,
            });
            if (_response.ok) {
                return {
                    data: serializers.accounting.PaginatedRemoteFieldClassList.parseOrThrow(_response.body, {
                        unrecognizedObjectKeys: "passthrough",
                        allowUnrecognizedUnionMembers: true,
                        allowUnrecognizedEnumValues: true,
                        skipValidation: true,
                        breadcrumbsPrefix: ["response"],
                    }),
                    rawResponse: _response.rawResponse,
                };
            }
            if (_response.error.reason === "status-code") {
                throw new errors.MergeError({
                    statusCode: _response.error.statusCode,
                    body: _response.error.body,
                });
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.MergeError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.MergeTimeoutError("Timeout exceeded when calling GET /accounting/v1/invoices/remote-field-classes.");
                case "unknown":
                    throw new errors.MergeError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    _getAuthorizationHeader() {
        return __awaiter(this, void 0, void 0, function* () {
            return `Bearer ${yield core.Supplier.get(this._options.apiKey)}`;
        });
    }
}
exports.Invoices = Invoices;
