/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace PaymentTerms {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class PaymentTerms {
    protected readonly _options: PaymentTerms.Options;
    constructor(_options: PaymentTerms.Options);
    /**
     * Returns a list of `PaymentTerm` objects.
     *
     * @param {Merge.accounting.PaymentTermsListRequest} request
     * @param {PaymentTerms.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.paymentTerms.list()
     */
    list(request?: Merge.accounting.PaymentTermsListRequest, requestOptions?: PaymentTerms.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedPaymentTermList>;
    private __list;
    /**
     * Returns a `PaymentTerm` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PaymentTermsRetrieveRequest} request
     * @param {PaymentTerms.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.paymentTerms.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.PaymentTermsRetrieveRequest, requestOptions?: PaymentTerms.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaymentTerm>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
