/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Payments {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Payments {
    protected readonly _options: Payments.Options;
    constructor(_options: Payments.Options);
    /**
     * Returns a list of `Payment` objects.
     *
     * @param {Merge.accounting.PaymentsListRequest} request
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.list()
     */
    list(request?: Merge.accounting.PaymentsListRequest, requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedPaymentList>;
    private __list;
    /**
     * Creates a `Payment` object with the given values.
     *
     * @param {Merge.accounting.PaymentEndpointRequest} request
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.PaymentEndpointRequest, requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaymentResponse>;
    private __create;
    /**
     * Returns a `Payment` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PaymentsRetrieveRequest} request
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.PaymentsRetrieveRequest, requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.Payment>;
    private __retrieve;
    /**
     * Updates a `Payment` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PatchedPaymentEndpointRequest} request
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id: string, request: Merge.accounting.PatchedPaymentEndpointRequest, requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaymentResponse>;
    private __partialUpdate;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.PaymentsLineItemsRemoteFieldClassesListRequest} request
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.lineItemsRemoteFieldClassesList()
     */
    lineItemsRemoteFieldClassesList(request?: Merge.accounting.PaymentsLineItemsRemoteFieldClassesListRequest, requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __lineItemsRemoteFieldClassesList;
    /**
     * Returns metadata for `Payment` PATCHs.
     *
     * @param {string} id
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id: string, requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPatchRetrieve;
    /**
     * Returns metadata for `Payment` POSTs.
     *
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.PaymentsRemoteFieldClassesListRequest} request
     * @param {Payments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.payments.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.accounting.PaymentsRemoteFieldClassesListRequest, requestOptions?: Payments.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
