/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace PurchaseOrders {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class PurchaseOrders {
    protected readonly _options: PurchaseOrders.Options;
    constructor(_options: PurchaseOrders.Options);
    /**
     * Returns a list of `PurchaseOrder` objects.
     *
     * @param {Merge.accounting.PurchaseOrdersListRequest} request
     * @param {PurchaseOrders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.purchaseOrders.list()
     */
    list(request?: Merge.accounting.PurchaseOrdersListRequest, requestOptions?: PurchaseOrders.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedPurchaseOrderList>;
    private __list;
    /**
     * Creates a `PurchaseOrder` object with the given values.
     *
     * @param {Merge.accounting.PurchaseOrderEndpointRequest} request
     * @param {PurchaseOrders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.purchaseOrders.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.PurchaseOrderEndpointRequest, requestOptions?: PurchaseOrders.RequestOptions): core.HttpResponsePromise<Merge.accounting.PurchaseOrderResponse>;
    private __create;
    /**
     * Returns a `PurchaseOrder` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PurchaseOrdersRetrieveRequest} request
     * @param {PurchaseOrders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.purchaseOrders.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.PurchaseOrdersRetrieveRequest, requestOptions?: PurchaseOrders.RequestOptions): core.HttpResponsePromise<Merge.accounting.PurchaseOrder>;
    private __retrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.PurchaseOrdersLineItemsRemoteFieldClassesListRequest} request
     * @param {PurchaseOrders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.purchaseOrders.lineItemsRemoteFieldClassesList()
     */
    lineItemsRemoteFieldClassesList(request?: Merge.accounting.PurchaseOrdersLineItemsRemoteFieldClassesListRequest, requestOptions?: PurchaseOrders.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __lineItemsRemoteFieldClassesList;
    /**
     * Returns metadata for `PurchaseOrder` POSTs.
     *
     * @param {PurchaseOrders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.purchaseOrders.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: PurchaseOrders.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.PurchaseOrdersRemoteFieldClassesListRequest} request
     * @param {PurchaseOrders.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.purchaseOrders.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.accounting.PurchaseOrdersRemoteFieldClassesListRequest, requestOptions?: PurchaseOrders.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
