/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace VendorCredits {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class VendorCredits {
    protected readonly _options: VendorCredits.Options;
    constructor(_options: VendorCredits.Options);
    /**
     * Returns a list of `VendorCredit` objects.
     *
     * @param {Merge.accounting.VendorCreditsListRequest} request
     * @param {VendorCredits.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.vendorCredits.list()
     */
    list(request?: Merge.accounting.VendorCreditsListRequest, requestOptions?: VendorCredits.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedVendorCreditList>;
    private __list;
    /**
     * Creates a `VendorCredit` object with the given values.
     *
     * @param {Merge.accounting.VendorCreditEndpointRequest} request
     * @param {VendorCredits.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.vendorCredits.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.VendorCreditEndpointRequest, requestOptions?: VendorCredits.RequestOptions): core.HttpResponsePromise<Merge.accounting.VendorCreditResponse>;
    private __create;
    /**
     * Returns a `VendorCredit` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.VendorCreditsRetrieveRequest} request
     * @param {VendorCredits.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.vendorCredits.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.VendorCreditsRetrieveRequest, requestOptions?: VendorCredits.RequestOptions): core.HttpResponsePromise<Merge.accounting.VendorCredit>;
    private __retrieve;
    /**
     * Returns metadata for `VendorCredit` POSTs.
     *
     * @param {VendorCredits.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.vendorCredits.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: VendorCredits.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
