/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The BankFeedTransaction Object
 * ### Description
 * The `BankFeedTransaction` object is used to represent transactions linked to a bank feed account. This includes details about the transaction such as the date, amount, description, and type.
 *
 * ### Usage Example
 * Fetch from the `GET BankFeedTransaction` endpoint to view details of a transaction associated with a bank feed account.
 */
export interface BankFeedTransaction {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The bank feed account associated with the transaction. */
    bankFeedAccount?: Merge.accounting.BankFeedTransactionBankFeedAccount;
    /** The date that the transaction occurred. */
    transactionDate?: Date;
    /** The date the transaction was posted to the bank account. */
    postedDate?: Date;
    /** The amount of the transaction. */
    amount?: number;
    /** The description of the transaction. */
    description?: string;
    /** The underlying type of the transaction. */
    transactionType?: string;
    /** The person or merchant who initiated the transaction, or alternatively, to whom the transaction was paid. */
    payee?: string;
    /**
     * If the transaction is of type debit or credit.
     *
     * * `CREDIT` - CREDIT
     * * `DEBIT` - DEBIT
     */
    creditOrDebit?: Merge.accounting.BankFeedTransactionCreditOrDebit;
    /** The customer’s identifier for the transaction. */
    sourceTransactionId?: string;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    /** Whether or not this transaction has been processed by the external system. For example, NetSuite writes this field as True when the SuiteApp has processed the transaction. */
    isProcessed?: boolean;
}
