/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The BankFeedTransaction Object
 * ### Description
 * The `BankFeedTransaction` object is used to represent transactions linked to a bank feed account. This includes details about the transaction such as the date, amount, description, and type.
 *
 * ### Usage Example
 * Fetch from the `GET BankFeedTransaction` endpoint to view details of a transaction associated with a bank feed account.
 */
export interface BankFeedTransactionRequestRequest {
    /** The bank feed account associated with the transaction. */
    bankFeedAccount?: Merge.accounting.BankFeedTransactionRequestRequestBankFeedAccount;
    /** The date that the transaction occurred. */
    transactionDate?: Date;
    /** The date the transaction was posted to the bank account. */
    postedDate?: Date;
    /** The amount of the transaction. */
    amount?: number;
    /** The description of the transaction. */
    description?: string;
    /** The underlying type of the transaction. */
    transactionType?: string;
    /** The person or merchant who initiated the transaction, or alternatively, to whom the transaction was paid. */
    payee?: string;
    /**
     * If the transaction is of type debit or credit.
     *
     * * `CREDIT` - CREDIT
     * * `DEBIT` - DEBIT
     */
    creditOrDebit?: Merge.accounting.BankFeedTransactionRequestRequestCreditOrDebit;
    /** The customer’s identifier for the transaction. */
    sourceTransactionId?: string;
    integrationParams?: Record<string, unknown>;
    linkedAccountParams?: Record<string, unknown>;
}
