/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The CreditNoteLineItem Object
 * ### Description
 * The `CreditNoteLineItem` object is used to represent a credit note's line items.
 *
 * ### Usage Example
 * Fetch from the `GET CreditNote` endpoint and view the credit note's line items.
 */
export interface CreditNoteLineItemRequest {
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    item?: Merge.accounting.CreditNoteLineItemRequestItem;
    /** The credit note line item's name. */
    name?: string;
    /** The description of the item that is owed. */
    description?: string;
    /** The credit note line item's quantity. */
    quantity?: string;
    /** The credit note line item's memo. */
    memo?: string;
    /** The credit note line item's unit price. */
    unitPrice?: string;
    /** The tax rate that applies to this line item. */
    taxRate?: string;
    /** The credit note line item's total. */
    totalLineAmount?: string;
    /** The credit note line item's associated tracking category. */
    trackingCategory?: string;
    /** The credit note line item's associated tracking categories. */
    trackingCategories?: (string | undefined)[];
    /** The credit note line item's account. */
    account?: string;
    /** The company the credit note belongs to. */
    company?: Merge.accounting.CreditNoteLineItemRequestCompany;
    integrationParams?: Record<string, unknown>;
    linkedAccountParams?: Record<string, unknown>;
}
