/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Employee Object
 * ### Description
 * An `Employee` is an individual who works for the company of the linked account. The `Employee` model contains both contractors and full time employees.
 * * An `Employee` is a contractor if `is_contractor` property is `True`
 * * An `Employee` is a full time employee if `is_contractor` property is `False`
 *
 * ### Usage Example
 * Fetch from the `LIST Employees` endpoint and view a company's employees.
 */
export interface Employee {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The employee's first name. */
    firstName?: string;
    /** The employee's last name. */
    lastName?: string;
    /** `True` if the employee is a contractor, `False` if not. */
    isContractor?: boolean;
    /** The employee's internal identification number. */
    employeeNumber?: string;
    /** The employee's email address. */
    emailAddress?: string;
    /** The subsidiary that the employee belongs to. */
    company?: Merge.accounting.EmployeeCompany;
    /**
     * The employee's status in the accounting system.
     *
     * * `ACTIVE` - ACTIVE
     * * `INACTIVE` - INACTIVE
     */
    status: Merge.accounting.EmployeeStatus;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.accounting.RemoteData[];
}
