/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The VendorCreditLine Object
 * ### Description
 * The `VendorCreditLine` object is used to represent a vendor credit's line items.
 *
 * ### Usage Example
 * Fetch from the `GET VendorCredit` endpoint and view the vendor credit's line items.
 */
export interface VendorCreditLine {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The full value of the credit. */
    netAmount?: number;
    /** The line's associated tracking category. */
    trackingCategory?: string;
    /** The vendor credit line item's associated tracking categories. */
    trackingCategories?: (string | undefined)[];
    /** The line's description. */
    description?: string;
    /** The line's account. */
    account?: Merge.accounting.VendorCreditLineAccount;
    /** The company the line belongs to. */
    company?: string;
    /** The tax rate that applies to this line item. */
    taxRate?: string;
    /** The vendor credit line item's exchange rate. */
    exchangeRate?: string;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
}
