/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Activities {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Activities {
    protected readonly _options: Activities.Options;
    constructor(_options: Activities.Options);
    /**
     * Returns a list of `Activity` objects.
     *
     * @param {Merge.ats.ActivitiesListRequest} request
     * @param {Activities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.activities.list()
     */
    list(request?: Merge.ats.ActivitiesListRequest, requestOptions?: Activities.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedActivityList>;
    private __list;
    /**
     * Creates an `Activity` object with the given values.
     *
     * @param {Merge.ats.ActivityEndpointRequest} request
     * @param {Activities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.activities.create({
     *         model: {},
     *         remoteUserId: "remote_user_id"
     *     })
     */
    create(request: Merge.ats.ActivityEndpointRequest, requestOptions?: Activities.RequestOptions): core.HttpResponsePromise<Merge.ats.ActivityResponse>;
    private __create;
    /**
     * Returns an `Activity` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.ActivitiesRetrieveRequest} request
     * @param {Activities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.activities.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.ActivitiesRetrieveRequest, requestOptions?: Activities.RequestOptions): core.HttpResponsePromise<Merge.ats.Activity>;
    private __retrieve;
    /**
     * Returns metadata for `Activity` POSTs.
     *
     * @param {Activities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.activities.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Activities.RequestOptions): core.HttpResponsePromise<Merge.ats.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
