/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Applications {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Applications {
    protected readonly _options: Applications.Options;
    constructor(_options: Applications.Options);
    /**
     * Returns a list of `Application` objects.
     *
     * @param {Merge.ats.ApplicationsListRequest} request
     * @param {Applications.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.applications.list()
     */
    list(request?: Merge.ats.ApplicationsListRequest, requestOptions?: Applications.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedApplicationList>;
    private __list;
    /**
     * Creates an `Application` object with the given values.
     * For certain integrations, but not all, our API detects duplicate candidates and will associate applications with existing records in the third-party. New candidates are created and automatically linked to the application.
     *
     * See our [Help Center article](https://help.merge.dev/en/articles/10012366-updates-to-post-applications-oct-2024) for detailed support per integration.
     *
     * @param {Merge.ats.ApplicationEndpointRequest} request
     * @param {Applications.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.applications.create({
     *         model: {},
     *         remoteUserId: "remote_user_id"
     *     })
     */
    create(request: Merge.ats.ApplicationEndpointRequest, requestOptions?: Applications.RequestOptions): core.HttpResponsePromise<Merge.ats.ApplicationResponse>;
    private __create;
    /**
     * Returns an `Application` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.ApplicationsRetrieveRequest} request
     * @param {Applications.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.applications.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.ApplicationsRetrieveRequest, requestOptions?: Applications.RequestOptions): core.HttpResponsePromise<Merge.ats.Application>;
    private __retrieve;
    /**
     * Updates the `current_stage` field of an `Application` object
     *
     * @param {string} id
     * @param {Merge.ats.UpdateApplicationStageRequest} request
     * @param {Applications.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.applications.changeStageCreate("id")
     */
    changeStageCreate(id: string, request?: Merge.ats.UpdateApplicationStageRequest, requestOptions?: Applications.RequestOptions): core.HttpResponsePromise<Merge.ats.ApplicationResponse>;
    private __changeStageCreate;
    /**
     * Returns metadata for `Application` POSTs.
     *
     * @param {Merge.ats.ApplicationsMetaPostRetrieveRequest} request
     * @param {Applications.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.applications.metaPostRetrieve()
     */
    metaPostRetrieve(request?: Merge.ats.ApplicationsMetaPostRetrieveRequest, requestOptions?: Applications.RequestOptions): core.HttpResponsePromise<Merge.ats.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
