/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Departments {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Departments {
    protected readonly _options: Departments.Options;
    constructor(_options: Departments.Options);
    /**
     * Returns a list of `Department` objects.
     *
     * @param {Merge.ats.DepartmentsListRequest} request
     * @param {Departments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.departments.list()
     */
    list(request?: Merge.ats.DepartmentsListRequest, requestOptions?: Departments.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedDepartmentList>;
    private __list;
    /**
     * Returns a `Department` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.DepartmentsRetrieveRequest} request
     * @param {Departments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.departments.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.DepartmentsRetrieveRequest, requestOptions?: Departments.RequestOptions): core.HttpResponsePromise<Merge.ats.Department>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
