/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace ForceResync {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class ForceResync {
    protected readonly _options: ForceResync.Options;
    constructor(_options: ForceResync.Options);
    /**
     * Force re-sync of all models. This endpoint is available for monthly, quarterly, and highest sync frequency customers on the Professional or Enterprise plans. Doing so will consume a sync credit for the relevant linked account. Force re-syncs can also be triggered manually in the Merge Dashboard and is available for all customers.
     *
     * @param {ForceResync.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.forceResync.syncStatusResyncCreate()
     */
    syncStatusResyncCreate(requestOptions?: ForceResync.RequestOptions): core.HttpResponsePromise<Merge.ats.SyncStatus[]>;
    private __syncStatusResyncCreate;
    protected _getAuthorizationHeader(): Promise<string>;
}
