/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Interviews {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Interviews {
    protected readonly _options: Interviews.Options;
    constructor(_options: Interviews.Options);
    /**
     * Returns a list of `ScheduledInterview` objects.
     *
     * @param {Merge.ats.InterviewsListRequest} request
     * @param {Interviews.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.interviews.list()
     */
    list(request?: Merge.ats.InterviewsListRequest, requestOptions?: Interviews.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedScheduledInterviewList>;
    private __list;
    /**
     * Creates a `ScheduledInterview` object with the given values.
     *
     * @param {Merge.ats.ScheduledInterviewEndpointRequest} request
     * @param {Interviews.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.interviews.create({
     *         model: {},
     *         remoteUserId: "remote_user_id"
     *     })
     */
    create(request: Merge.ats.ScheduledInterviewEndpointRequest, requestOptions?: Interviews.RequestOptions): core.HttpResponsePromise<Merge.ats.ScheduledInterviewResponse>;
    private __create;
    /**
     * Returns a `ScheduledInterview` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.InterviewsRetrieveRequest} request
     * @param {Interviews.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.interviews.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.InterviewsRetrieveRequest, requestOptions?: Interviews.RequestOptions): core.HttpResponsePromise<Merge.ats.ScheduledInterview>;
    private __retrieve;
    /**
     * Returns metadata for `ScheduledInterview` POSTs.
     *
     * @param {Interviews.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.interviews.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Interviews.RequestOptions): core.HttpResponsePromise<Merge.ats.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
