/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Offices {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Offices {
    protected readonly _options: Offices.Options;
    constructor(_options: Offices.Options);
    /**
     * Returns a list of `Office` objects.
     *
     * @param {Merge.ats.OfficesListRequest} request
     * @param {Offices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.offices.list()
     */
    list(request?: Merge.ats.OfficesListRequest, requestOptions?: Offices.RequestOptions): core.HttpResponsePromise<Merge.ats.PaginatedOfficeList>;
    private __list;
    /**
     * Returns an `Office` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ats.OfficesRetrieveRequest} request
     * @param {Offices.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.offices.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ats.OfficesRetrieveRequest, requestOptions?: Offices.RequestOptions): core.HttpResponsePromise<Merge.ats.Office>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
