/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Passthrough {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Passthrough {
    protected readonly _options: Passthrough.Options;
    constructor(_options: Passthrough.Options);
    /**
     * Pull data from an endpoint not currently supported by Merge.
     *
     * @param {Merge.ats.DataPassthroughRequest} request
     * @param {Passthrough.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ats.passthrough.create({
     *         method: "GET",
     *         path: "/scooters"
     *     })
     */
    create(request: Merge.ats.DataPassthroughRequest, requestOptions?: Passthrough.RequestOptions): core.HttpResponsePromise<Merge.ats.RemoteResponse>;
    private __create;
    protected _getAuthorizationHeader(): Promise<string>;
}
