/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The JobPosting Object
 * ### Description
 * The `JobPosting` object represents an external announcement on a job board created by an organization to attract qualified candidates to apply for a specific `Job` opening
 * ### Usage Example
 * Fetch from the `LIST JobPostings` endpoint to show all job postings.
 */
export interface JobPosting {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The job posting’s title. */
    title?: string;
    /** The Url object is used to represent hyperlinks for a candidate to apply to a given job. */
    jobPostingUrls?: Merge.ats.JobPostingJobPostingUrlsItem[];
    /** ID of `Job` object for this `JobPosting`. */
    job?: Merge.ats.JobPostingJob;
    /**
     * The job posting's status.
     *
     * * `PUBLISHED` - PUBLISHED
     * * `CLOSED` - CLOSED
     * * `DRAFT` - DRAFT
     * * `INTERNAL` - INTERNAL
     * * `PENDING` - PENDING
     */
    status?: Merge.ats.JobPostingStatusEnum;
    /** The job posting’s content. */
    content?: string;
    /** When the third party's job posting was created. */
    remoteCreatedAt?: Date;
    /** When the third party's job posting was updated. */
    remoteUpdatedAt?: Date;
    /** Indicates whether the job posting is internal or external. */
    isInternal?: boolean;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.ats.RemoteData[];
}
