/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Scorecard Object
 * ### Description
 * The `Scorecard` object is used to represent an interviewer's candidate recommendation based on a particular interview.
 * ### Usage Example
 * Fetch from the `LIST Scorecards` endpoint and filter by `application` to show all scorecard for an applicant.
 */
export interface Scorecard {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The application being scored. */
    application?: Merge.ats.ScorecardApplication;
    /** The interview being scored. */
    interview?: Merge.ats.ScorecardInterview;
    /** The interviewer doing the scoring. */
    interviewer?: Merge.ats.ScorecardInterviewer;
    /** When the third party's scorecard was created. */
    remoteCreatedAt?: Date;
    /** When the scorecard was submitted. */
    submittedAt?: Date;
    /**
     * The inteviewer's recommendation.
     *
     * * `DEFINITELY_NO` - DEFINITELY_NO
     * * `NO` - NO
     * * `YES` - YES
     * * `STRONG_YES` - STRONG_YES
     * * `NO_DECISION` - NO_DECISION
     */
    overallRecommendation?: Merge.ats.ScorecardOverallRecommendation;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.ats.RemoteData[];
}
