/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace AccountToken {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class AccountToken {
    protected readonly _options: AccountToken.Options;
    constructor(_options: AccountToken.Options);
    /**
     * Returns the account token for the end user with the provided public token.
     *
     * @param {string} publicToken
     * @param {AccountToken.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.accountToken.retrieve("public_token")
     */
    retrieve(publicToken: string, requestOptions?: AccountToken.RequestOptions): core.HttpResponsePromise<Merge.crm.AccountToken>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
