/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace EngagementTypes {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class EngagementTypes {
    protected readonly _options: EngagementTypes.Options;
    constructor(_options: EngagementTypes.Options);
    /**
     * Returns a list of `EngagementType` objects.
     *
     * @param {Merge.crm.EngagementTypesListRequest} request
     * @param {EngagementTypes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagementTypes.list()
     */
    list(request?: Merge.crm.EngagementTypesListRequest, requestOptions?: EngagementTypes.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedEngagementTypeList>;
    private __list;
    /**
     * Returns an `EngagementType` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.EngagementTypesRetrieveRequest} request
     * @param {EngagementTypes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagementTypes.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.EngagementTypesRetrieveRequest, requestOptions?: EngagementTypes.RequestOptions): core.HttpResponsePromise<Merge.crm.EngagementType>;
    private __retrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.EngagementTypesRemoteFieldClassesListRequest} request
     * @param {EngagementTypes.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagementTypes.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.EngagementTypesRemoteFieldClassesListRequest, requestOptions?: EngagementTypes.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
