/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Engagements {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Engagements {
    protected readonly _options: Engagements.Options;
    constructor(_options: Engagements.Options);
    /**
     * Returns a list of `Engagement` objects.
     *
     * @param {Merge.crm.EngagementsListRequest} request
     * @param {Engagements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagements.list()
     */
    list(request?: Merge.crm.EngagementsListRequest, requestOptions?: Engagements.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedEngagementList>;
    private __list;
    /**
     * Creates an `Engagement` object with the given values.
     *
     * @param {Merge.crm.EngagementEndpointRequest} request
     * @param {Engagements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagements.create({
     *         model: {}
     *     })
     */
    create(request: Merge.crm.EngagementEndpointRequest, requestOptions?: Engagements.RequestOptions): core.HttpResponsePromise<Merge.crm.EngagementResponse>;
    private __create;
    /**
     * Returns an `Engagement` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.EngagementsRetrieveRequest} request
     * @param {Engagements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagements.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.EngagementsRetrieveRequest, requestOptions?: Engagements.RequestOptions): core.HttpResponsePromise<Merge.crm.Engagement>;
    private __retrieve;
    /**
     * Updates an `Engagement` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.PatchedEngagementEndpointRequest} request
     * @param {Engagements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagements.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id: string, request: Merge.crm.PatchedEngagementEndpointRequest, requestOptions?: Engagements.RequestOptions): core.HttpResponsePromise<Merge.crm.EngagementResponse>;
    private __partialUpdate;
    /**
     * Returns metadata for `Engagement` PATCHs.
     *
     * @param {string} id
     * @param {Engagements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagements.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id: string, requestOptions?: Engagements.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPatchRetrieve;
    /**
     * Returns metadata for `Engagement` POSTs.
     *
     * @param {Engagements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagements.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Engagements.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.EngagementsRemoteFieldClassesListRequest} request
     * @param {Engagements.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.engagements.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.EngagementsRemoteFieldClassesListRequest, requestOptions?: Engagements.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
