/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Opportunities {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Opportunities {
    protected readonly _options: Opportunities.Options;
    constructor(_options: Opportunities.Options);
    /**
     * Returns a list of `Opportunity` objects.
     *
     * @param {Merge.crm.OpportunitiesListRequest} request
     * @param {Opportunities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.opportunities.list()
     */
    list(request?: Merge.crm.OpportunitiesListRequest, requestOptions?: Opportunities.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedOpportunityList>;
    private __list;
    /**
     * Creates an `Opportunity` object with the given values.
     *
     * @param {Merge.crm.OpportunityEndpointRequest} request
     * @param {Opportunities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.opportunities.create({
     *         model: {}
     *     })
     */
    create(request: Merge.crm.OpportunityEndpointRequest, requestOptions?: Opportunities.RequestOptions): core.HttpResponsePromise<Merge.crm.OpportunityResponse>;
    private __create;
    /**
     * Returns an `Opportunity` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.OpportunitiesRetrieveRequest} request
     * @param {Opportunities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.opportunities.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.OpportunitiesRetrieveRequest, requestOptions?: Opportunities.RequestOptions): core.HttpResponsePromise<Merge.crm.Opportunity>;
    private __retrieve;
    /**
     * Updates an `Opportunity` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.PatchedOpportunityEndpointRequest} request
     * @param {Opportunities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.opportunities.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id: string, request: Merge.crm.PatchedOpportunityEndpointRequest, requestOptions?: Opportunities.RequestOptions): core.HttpResponsePromise<Merge.crm.OpportunityResponse>;
    private __partialUpdate;
    /**
     * Returns metadata for `Opportunity` PATCHs.
     *
     * @param {string} id
     * @param {Opportunities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.opportunities.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id: string, requestOptions?: Opportunities.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPatchRetrieve;
    /**
     * Returns metadata for `Opportunity` POSTs.
     *
     * @param {Opportunities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.opportunities.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Opportunities.RequestOptions): core.HttpResponsePromise<Merge.crm.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.OpportunitiesRemoteFieldClassesListRequest} request
     * @param {Opportunities.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.opportunities.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.OpportunitiesRemoteFieldClassesListRequest, requestOptions?: Opportunities.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
