/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Stages {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Stages {
    protected readonly _options: Stages.Options;
    constructor(_options: Stages.Options);
    /**
     * Returns a list of `Stage` objects.
     *
     * @param {Merge.crm.StagesListRequest} request
     * @param {Stages.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.stages.list()
     */
    list(request?: Merge.crm.StagesListRequest, requestOptions?: Stages.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedStageList>;
    private __list;
    /**
     * Returns a `Stage` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.crm.StagesRetrieveRequest} request
     * @param {Stages.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.stages.retrieve("id")
     */
    retrieve(id: string, request?: Merge.crm.StagesRetrieveRequest, requestOptions?: Stages.RequestOptions): core.HttpResponsePromise<Merge.crm.Stage>;
    private __retrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.crm.StagesRemoteFieldClassesListRequest} request
     * @param {Stages.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.crm.stages.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.crm.StagesRemoteFieldClassesListRequest, requestOptions?: Stages.RequestOptions): core.HttpResponsePromise<Merge.crm.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
