/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Contact Object
 * ### Description
 * The `Contact` object is used to represent an existing point of contact at a company in a CRM system.
 * ### Usage Example
 * TODO
 */
export interface Contact {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The contact's first name. */
    firstName?: string;
    /** The contact's last name. */
    lastName?: string;
    /** The contact's account. */
    account?: Merge.crm.ContactAccount;
    /** The contact's owner. */
    owner?: Merge.crm.ContactOwner;
    addresses?: Merge.crm.Address[];
    emailAddresses?: Merge.crm.EmailAddress[];
    phoneNumbers?: Merge.crm.PhoneNumber[];
    /** When the contact's last activity occurred. */
    lastActivityAt?: Date;
    /** When the third party's contact was created. */
    remoteCreatedAt?: Date;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.crm.RemoteData[];
    remoteFields?: Merge.crm.RemoteField[];
}
