/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Engagement Object
 * ### Description
 * The `Engagement` object is used to represent an interaction noted in a CRM system.
 * ### Usage Example
 * TODO
 */
export interface Engagement {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The engagement's owner. */
    owner?: Merge.crm.EngagementOwner;
    /** The engagement's content. */
    content?: string;
    /** The engagement's subject. */
    subject?: string;
    /**
     * The engagement's direction.
     *
     * * `INBOUND` - INBOUND
     * * `OUTBOUND` - OUTBOUND
     */
    direction?: Merge.crm.EngagementDirection;
    /** The engagement type of the engagement. */
    engagementType?: Merge.crm.EngagementEngagementType;
    /** The time at which the engagement started. */
    startTime?: Date;
    /** The time at which the engagement ended. */
    endTime?: Date;
    /** The account of the engagement. */
    account?: Merge.crm.EngagementAccount;
    contacts?: (Merge.crm.EngagementContactsItem | undefined)[];
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.crm.RemoteData[];
    remoteFields?: Merge.crm.RemoteField[];
}
