/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Folder Object
 * ### Description
 * The `Folder` object is used to represent a collection of files and/or folders in the workspace. Could be within a drive, if it exists.
 * ### Usage Example
 * Fetch from the `GET /api/filestorage/v1/folders` endpoint and view their folders.
 */
export interface FolderRequest {
    /** The folder's name. */
    name?: string;
    /** The URL to access the folder. */
    folderUrl?: string;
    /** The folder's size, in bytes. */
    size?: number;
    /** The folder's description. */
    description?: string;
    /** The folder that the folder belongs to. */
    parentFolder?: Merge.filestorage.FolderRequestParentFolder;
    /** The drive that the folder belongs to. */
    drive?: Merge.filestorage.FolderRequestDrive;
    /** The Permission object is used to represent a user's or group's access to a File or Folder. Permissions are unexpanded by default. Use the query param `expand=permissions` to see more details under `GET /folders`. */
    permissions?: Merge.filestorage.FolderRequestPermissions;
    integrationParams?: Record<string, unknown>;
    linkedAccountParams?: Record<string, unknown>;
}
