/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The User Object
 * ### Description
 * The `User` object is used to represent a user within the File Storage account.
 * ### Usage Example
 * Fetch from the `GET /api/filestorage/v1/users` endpoint and view their users.
 */
export interface User {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The user's name. */
    name?: string;
    /** The user's email address. This is typically used to identify a user across linked accounts. */
    emailAddress?: string;
    /** Whether the user is the one who linked this account. */
    isMe?: boolean;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.filestorage.RemoteData[];
}
