/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace BankInfo {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class BankInfo {
    protected readonly _options: BankInfo.Options;
    constructor(_options: BankInfo.Options);
    /**
     * Returns a list of `BankInfo` objects.
     *
     * @param {Merge.hris.BankInfoListRequest} request
     * @param {BankInfo.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.bankInfo.list()
     */
    list(request?: Merge.hris.BankInfoListRequest, requestOptions?: BankInfo.RequestOptions): core.HttpResponsePromise<Merge.hris.PaginatedBankInfoList>;
    private __list;
    /**
     * Returns a `BankInfo` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.hris.BankInfoRetrieveRequest} request
     * @param {BankInfo.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.bankInfo.retrieve("id")
     */
    retrieve(id: string, request?: Merge.hris.BankInfoRetrieveRequest, requestOptions?: BankInfo.RequestOptions): core.HttpResponsePromise<Merge.hris.BankInfo>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
