/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace LinkToken {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class LinkToken {
    protected readonly _options: LinkToken.Options;
    constructor(_options: LinkToken.Options);
    /**
     * Creates a link token to be used when linking a new end user.
     *
     * @param {Merge.hris.EndUserDetailsRequest} request
     * @param {LinkToken.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.linkToken.create({
     *         endUserEmailAddress: "example@gmail.com",
     *         endUserOrganizationName: "Test Organization",
     *         endUserOriginId: "12345",
     *         categories: ["hris", "ats"]
     *     })
     */
    create(request: Merge.hris.EndUserDetailsRequest, requestOptions?: LinkToken.RequestOptions): core.HttpResponsePromise<Merge.hris.LinkToken>;
    private __create;
    protected _getAuthorizationHeader(): Promise<string>;
}
