/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace TimeOff {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class TimeOff {
    protected readonly _options: TimeOff.Options;
    constructor(_options: TimeOff.Options);
    /**
     * Returns a list of `TimeOff` objects.
     *
     * @param {Merge.hris.TimeOffListRequest} request
     * @param {TimeOff.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timeOff.list()
     */
    list(request?: Merge.hris.TimeOffListRequest, requestOptions?: TimeOff.RequestOptions): core.HttpResponsePromise<Merge.hris.PaginatedTimeOffList>;
    private __list;
    /**
     * Creates a `TimeOff` object with the given values.
     *
     * @param {Merge.hris.TimeOffEndpointRequest} request
     * @param {TimeOff.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timeOff.create({
     *         model: {}
     *     })
     */
    create(request: Merge.hris.TimeOffEndpointRequest, requestOptions?: TimeOff.RequestOptions): core.HttpResponsePromise<Merge.hris.TimeOffResponse>;
    private __create;
    /**
     * Returns a `TimeOff` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.hris.TimeOffRetrieveRequest} request
     * @param {TimeOff.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timeOff.retrieve("id")
     */
    retrieve(id: string, request?: Merge.hris.TimeOffRetrieveRequest, requestOptions?: TimeOff.RequestOptions): core.HttpResponsePromise<Merge.hris.TimeOff>;
    private __retrieve;
    /**
     * Returns metadata for `TimeOff` POSTs.
     *
     * @param {TimeOff.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.hris.timeOff.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: TimeOff.RequestOptions): core.HttpResponsePromise<Merge.hris.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
