/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Company Object
 * ### Description
 * The `Company` object is used to represent a company within the HRIS / Payroll system.
 *
 * ### Usage Example
 * Fetch from the `LIST Companies` endpoint and filter by `ID` to show all companies.
 */
export interface Company {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The company's legal name. */
    legalName?: string;
    /** The company's display name. */
    displayName?: string;
    /** The company's Employer Identification Numbers. */
    eins?: (string | undefined)[];
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.hris.RemoteData[];
}
