/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The TimeOffBalance Object
 * ### Description
 * The `TimeOffBalance` object is used to represent current balances for an employee's Time Off plan.
 *
 * ### Usage Example
 * Fetch from the `LIST TimeOffBalances` endpoint and filter by `ID` to show all time off balances.
 */
export interface TimeOffBalance {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The employee the balance belongs to. */
    employee?: Merge.hris.TimeOffBalanceEmployee;
    /** The current remaining PTO balance, measured in hours. For integrations that return this value in days, Merge multiplies by 8 to calculate hours. */
    balance?: number;
    /** The amount of PTO used in terms of hours. For integrations that return this value in days, Merge multiplies by 8 to calculate hours. */
    used?: number;
    /**
     * The policy type of this time off balance.
     *
     * * `VACATION` - VACATION
     * * `SICK` - SICK
     * * `PERSONAL` - PERSONAL
     * * `JURY_DUTY` - JURY_DUTY
     * * `VOLUNTEER` - VOLUNTEER
     * * `BEREAVEMENT` - BEREAVEMENT
     */
    policyType?: Merge.hris.TimeOffBalancePolicyType;
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.hris.RemoteData[];
}
