/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
import * as stream from "stream";
export declare namespace Attachments {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Attachments {
    protected readonly _options: Attachments.Options;
    constructor(_options: Attachments.Options);
    /**
     * Returns a list of `Attachment` objects.
     *
     * @param {Merge.ticketing.AttachmentsListRequest} request
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.attachments.list()
     */
    list(request?: Merge.ticketing.AttachmentsListRequest, requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedAttachmentList>;
    private __list;
    /**
     * Creates an `Attachment` object with the given values.
     *
     * @param {Merge.ticketing.TicketingAttachmentEndpointRequest} request
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.attachments.create({
     *         model: {}
     *     })
     */
    create(request: Merge.ticketing.TicketingAttachmentEndpointRequest, requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.TicketingAttachmentResponse>;
    private __create;
    /**
     * Returns an `Attachment` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ticketing.AttachmentsRetrieveRequest} request
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.attachments.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ticketing.AttachmentsRetrieveRequest, requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.Attachment>;
    private __retrieve;
    /**
     * Returns the `File` content with the given `id` as a stream of bytes.
     */
    downloadRetrieve(id: string, request?: Merge.ticketing.AttachmentsDownloadRetrieveRequest, requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<stream.Readable>;
    private __downloadRetrieve;
    /**
     * Returns metadata for `TicketingAttachment` POSTs.
     *
     * @param {Attachments.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.attachments.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Attachments.RequestOptions): core.HttpResponsePromise<Merge.ticketing.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
