/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Collections {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Collections {
    protected readonly _options: Collections.Options;
    constructor(_options: Collections.Options);
    /**
     * Returns a list of `Collection` objects.
     *
     * @param {Merge.ticketing.CollectionsListRequest} request
     * @param {Collections.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.collections.list()
     */
    list(request?: Merge.ticketing.CollectionsListRequest, requestOptions?: Collections.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedCollectionList>;
    private __list;
    /**
     * Returns a list of `Viewer` objects that point to a User id or Team id that is either an assignee or viewer on a `Collection` with the given id. [Learn more.](https://help.merge.dev/en/articles/10333658-ticketing-access-control-list-acls)
     *
     * @param {string} collectionId
     * @param {Merge.ticketing.CollectionsViewersListRequest} request
     * @param {Collections.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.collections.viewersList("collection_id")
     */
    viewersList(collectionId: string, request?: Merge.ticketing.CollectionsViewersListRequest, requestOptions?: Collections.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedViewerList>;
    private __viewersList;
    /**
     * Returns a `Collection` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ticketing.CollectionsRetrieveRequest} request
     * @param {Collections.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.collections.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ticketing.CollectionsRetrieveRequest, requestOptions?: Collections.RequestOptions): core.HttpResponsePromise<Merge.ticketing.Collection>;
    private __retrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
