/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Tickets {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class Tickets {
    protected readonly _options: Tickets.Options;
    constructor(_options: Tickets.Options);
    /**
     * Returns a list of `Ticket` objects.
     *
     * @param {Merge.ticketing.TicketsListRequest} request
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.list()
     */
    list(request?: Merge.ticketing.TicketsListRequest, requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedTicketList>;
    private __list;
    /**
     * Creates a `Ticket` object with the given values.
     *
     * @param {Merge.ticketing.TicketEndpointRequest} request
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.create({
     *         model: {}
     *     })
     */
    create(request: Merge.ticketing.TicketEndpointRequest, requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.TicketResponse>;
    private __create;
    /**
     * Returns a `Ticket` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ticketing.TicketsRetrieveRequest} request
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.retrieve("id")
     */
    retrieve(id: string, request?: Merge.ticketing.TicketsRetrieveRequest, requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.Ticket>;
    private __retrieve;
    /**
     * Updates a `Ticket` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.ticketing.PatchedTicketEndpointRequest} request
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id: string, request: Merge.ticketing.PatchedTicketEndpointRequest, requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.TicketResponse>;
    private __partialUpdate;
    /**
     * Returns a list of `Viewer` objects that point to a User id or Team id that is either an assignee or viewer on a `Ticket` with the given id. [Learn more.](https://help.merge.dev/en/articles/10333658-ticketing-access-control-list-acls)
     *
     * @param {string} ticketId
     * @param {Merge.ticketing.TicketsViewersListRequest} request
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.viewersList("ticket_id")
     */
    viewersList(ticketId: string, request?: Merge.ticketing.TicketsViewersListRequest, requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedViewerList>;
    private __viewersList;
    /**
     * Returns metadata for `Ticket` PATCHs.
     *
     * @param {string} id
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id: string, requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.MetaResponse>;
    private __metaPatchRetrieve;
    /**
     * Returns metadata for `Ticket` POSTs.
     *
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.ticketing.TicketsRemoteFieldClassesListRequest} request
     * @param {Tickets.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.ticketing.tickets.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.ticketing.TicketsRemoteFieldClassesListRequest, requestOptions?: Tickets.RequestOptions): core.HttpResponsePromise<Merge.ticketing.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
