/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Account Object
 * ### Description
 * The `Account` object is used to represent the account that a ticket is associated with.
 *
 * The account is a company that may be a customer. This does not represent the company that is receiving the ticket.
 *
 * ### Usage Example
 * TODO
 */
export interface Account {
    id?: string;
    /** The third-party API ID of the matching object. */
    remoteId?: string;
    /** The datetime that this object was created by Merge. */
    createdAt?: Date;
    /** The datetime that this object was modified by Merge. */
    modifiedAt?: Date;
    /** The account's name. */
    name?: string;
    /** The account's domain names. */
    domains?: (string | undefined)[];
    /** Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/). */
    remoteWasDeleted?: boolean;
    fieldMappings?: Record<string, unknown>;
    remoteData?: Merge.ticketing.RemoteData[];
}
